#!/usr/bin/perl

###############################################################################
# UltraRank.pl                                                                #
###############################################################################
# UltraRank Ver. 1.00b by UltraScripts.com                                    #
# Scripts written by Jacky W.W. Yung, WebMaster@UltraScripts.com              #
# Documents written by Jeff Bradbury, Glacier@UltraScripts.com                #
# Available from http://www.UltraScripts.com/UltraRank/                       #
# --------------------------------------------------------------------------- #
# PROGRAM NAME : UltraRank                                                    #
# VERSION : 1.00 Beta                                                         #
# LAST MODIFIED : 04/15/1999                                                  #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999 Jacky Yung. All Rights Reserved.                         #
#                                                                             #
# This program is free software; you can redistribute it and/or modify it     #
# under the terms of the GNU General Public License as published by the Free  #
# Software Foundation; either version 2 of the License, or (at your option)   #
# any later version.                                                          #
#                                                                             #
# This program is distributed in the hope that it will be useful, but WITHOUT #
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or       #
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for   #
# more details.                                                               #
#                                                                             #
# You should have received a copy of the GNU General Public License along'    #
# with this program; if not, write to the Free Software Foundation, Inc., 59  #
# Temple Place - Suite 330, Boston, MA  02111-1307, USA.                      #
###############################################################################

require "./UltraRank.lib";
require "./UltraRank.var";

&UltraRank::ParseForm;

if ($UltraRank::input{'action'} eq "in") {
	if ($UltraRank::input{'ID'}) {
		if ($Con{'AntiCheat'} eq "on") {
			$Ref = $ENV{'HTTP_REFERER'};
			if ($Ref=~/UltraRank.pl/) {
				&CheckTime;
				&AddHit;
			}else{
				&UltraRank::PrintHTMLHeader;
				open(HTML,"$Con{'DataPath'}/Gateway.dat") || &UltraRank::ShowScriptError("Coundn't create the Gateway.dat file");
					while(<HTML>){
						$_=~s/\<--ULTRARANK_LINK--\>/$Con{'URLCGI'}\/UltraRank.pl\?action\=in\&ID=$UltraRank::input{'ID'}/g;
						print $_;
					}
				close(HTML);
			}
		}else{
			&CheckTime;
			&AddHit;
		}
	}else{
		print "Location: $Con{'URLHTML'}/$Con{'ListFileName'}.$Con{'ListFileExt'}\n\n";
	}
}elsif ($UltraRank::input{'action'} eq "out") {
	if ($UltraRank::input{'ID'}) {
		&AddOut;
	}else{
		&UltraRank::ShowError("ID PROBLEM", "No member has this ID.");
	}
}else{
	print "Location: $Con{'URLHTML'}/$Con{'ListFileName'}.$Con{'ListFileExt'}\n\n";
}
exit;

###############################################################################
# CheckTime                                                                   #
###############################################################################
sub CheckTime {
	require "$Con{'DataPath'}/Reset.dat";
	if (!$Con{'UseCron'}) {
		$CurTime=time;
		$ReListTime=$CurTime-$TIME{'ReListTime'};
		if ($ReListTime>=$Con{'TimeToUpdate'}) {
			&UltraRank::ReList();
		}
		$ResetTime=$CurTime-$TIME{'ResetTime'};
		if ($ResetTime>=$Con{'TimeToReset'}) {
			$ReListTime=$TIME{'ReListTime'};
			open(TIME, ">$Con{'DataPath'}/Reset.dat") || &UltraRank::ShowScriptError("Couldn't locate the Reset.dat file.");
				print TIME "\$TIME{'ReListTime'}=$ReListTime;\n";
				print TIME "\$TIME{'ResetTime'}=$CurTime;\n";
				print TIME "1;";
			close(TIME);
			&UltraRank::Reset;
		}
	}
	print "Location: $Con{'URLHTML'}/$Con{'ListFileName'}.$Con{'ListFileExt'}\n\n";
}

###############################################################################
# AddHit                                                                      #
###############################################################################
sub AddHit {
	$ID=$UltraRank::input{'ID'};
	if (-e "$Con{'MembersPath'}/$ID.dat") {
		open(IP,"$Con{'MembersPath'}/$ID.log") || &UltraRank::ShowScriptError("Couldn't locate the $ID.log file.");
			@IP=<IP>;
		close(IP);
		$CurIP = $ENV{'REMOTE_ADDR'};
		for (@IP) {
			chomp($_);
			if ($_ eq $CurIP) {
				&WriteErrorLog("Double click throughs: $ID");
				exit;
			}
		}
		open(IP,">>$Con{'MembersPath'}/$ID.log") || &UltraRank::ShowScriptError("Couldn't locate the $ID.log file.");
			print IP "$CurIP\n";
		close(IP);
		#Total Hits |^| Hits In |^| Hits Out |^| Time |^| Password |^| Email |^| Site Title |^| Site Description |^| Site URL |^| Banner URL |^| Last Click |^| Status
		open(INFO,"$Con{'MembersPath'}/$ID.dat") || &UltraRank::ShowScriptError("Couldn't locate the $ID.dat file.");
			@INFO=split(/\|\^\|/,<INFO>);
		close(INFO);
		open(INFO,">$Con{'MembersPath'}/$ID.dat") || &UltraRank::ShowScriptError("Couldn't locate the $ID.dat file.");
			flock(INFO,2) if ($Con{'UseLock'});
				@INFO[0]++;
				@INFO[1]++;
				@INFO[10]=time;
				$LINE=join("\|\^\|",@INFO);
				print INFO $LINE;
			flock(INFO,8) if ($Con{'UseLock'});
		close(INFO);
		open(STAT,"$Con{'DataPath'}/Stats.dat") || &UltraRank::ShowScriptError("Couldn't locate the Stats.dat file.");
			@STATS=split(/\|\^\|/,<STAT>);
		close(STAT);
		open(STAT,">$Con{'DataPath'}/Stats.dat") || &UltraRank::ShowScriptError("Couldn't locate the Stats.dat file.");
			flock(STAT,2) if ($Con{'UseLock'});
				@STATS[0]++;
				@STATS[1]++;
				print STAT @STATS[0]."\|\^\|".@STATS[1]."\|\^\|".@STATS[2];
			flock(STAT,8) if ($Con{'UseLock'});
		close(STAT);
	}
}

###############################################################################
# AddOut                                                                      #
###############################################################################
sub AddOut {
	$ID=$UltraRank::input{'ID'};
	if (-e "$Con{'MembersPath'}/$ID.dat") {
		open(INFO,"$Con{'MembersPath'}/$ID.dat") || &UltraRank::ShowScriptError("Couldn't locate the $ID.dat file.");
			@INFO=split(/\|\^\|/,<INFO>);
		close(INFO);
		@INFO[2]++;
		open(INFO,">$Con{'MembersPath'}/$ID.dat") || &UltraRank::ShowScriptError("Couldn't locate the $ID.dat file.");
			$LINE=join("\|\^\|",@INFO);
			print INFO $LINE;
		close(INFO);
		open(STAT,"$Con{'DataPath'}/Stats.dat") || &UltraRank::ShowScriptError("Couldn't locate the Stats.dat file.");
			@STATS=split(/\|\^\|/,<STAT>);
		close(STAT);
		open(STAT,">$Con{'DataPath'}/Stats.dat") || &UltraRank::ShowScriptError("Couldn't locate the Stats.dat file.");
			flock(STAT,2) if ($Con{'UseLock'});
				print STAT @STATS[0]."\|\^\|".@STATS[1]."\|\^\|".++@STATS[2];
			flock(STAT,8) if ($Con{'UseLock'});
		close(STAT);
		print "Location: @INFO[8]\n\n";
	}else{
		&UltraRank::ShowError("ID PROBLEM", "No member has this ID.");
	}
}

###############################################################################
# WriteErrorLog                                                               #
###############################################################################
sub WriteErrorLog {
	local $Error = shift;
	if($Con{'LogErrors'}) {
		open(ERROR, ">>$Con{'DataPath'}/Errors.log");
			print ERROR time." | $ENV{'REMOTE_ADDR'} | Cheating | $Error\n";
		close(ERROR);
	}
}