#!/usr/local/bin/perl

###############################################################################
# URAccount.pl                                                                #
###############################################################################
# UltraRank Ver. 1.00b by UltraScripts.com                                    #
# Written by Jacky W.W. Yung, WebMaster@UltraScripts.com                      #
# Available from http://www.UltraScripts.com/UltraRanks/                      #
# --------------------------------------------------------------------------- #
# PROGRAM NAME : UltraRank                                                    #
# VERSION : 1.00 Beta                                                         #
# LAST MODIFIED : 04/15/1999                                                  #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999 Jacky Yung. All Rights Reserved.                         #
#                                                                             #
# This program is free software; you can redistribute it and/or modify it     #
# under the terms of the GNU General Public License as published by the Free  #
# Software Foundation; either version 2 of the License, or (at your option)   #
# any later version.                                                          #
#                                                                             #
# This program is distributed in the hope that it will be useful, but WITHOUT #
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or       #
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for   #
# more details.                                                               #
#                                                                             #
# You should have received a copy of the GNU General Public License along'    #
# with this program; if not, write to the Free Software Foundation, Inc., 59  #
# Temple Place - Suite 330, Boston, MA  02111-1307, USA.                      #
###############################################################################

require "./UltraRank.var";
require "./UltraRank.lib";

&UltraRank::ParseForm;

if ($UltraRank::input{'action'} eq ""){
	&Login;
}elsif ($UltraRank::input{'action'} eq "DoAddMember") {
	&DoAddMember;
}elsif ($UltraRank::input{'action'} eq "Control") {
	$UltraRank::input{'Password'}=crypt($UltraRank::input{'Password'},"ab");
	&Control;
}elsif ($UltraRank::input{'action'} eq "DoEditAccount") {
	&DoEditAccount;
}elsif ($UltraRank::input{'action'} eq "MainMenu") {
	&MainMenu;
}elsif ($UltraRank::input{'action'} eq "MainMenu") {
	&MainMenu;
}else{
	&Login;
}
exit;

###############################################################################
# Login                                                                       #
###############################################################################
sub Login {
	&UltraRank::PrintHTMLHeader;
	$HTML=qq~
<form method=post action="$Con{'URLCGI'}/URAccount.pl">
<input type=hidden name="action" value="Control">
<table width="580" align="center" border="0" cellspacing="0" cellpadding="1" bgcolor="000000">
	<tr><td>
		<table width="100%" cellspacing="1" cellpadding="5" background="">
			<tr bgcolor="0080FF"><td colspan="2"><font face="Arial" color="FFFFFF" size="2"><b>LOGIN</b></font></td></tr>
			<tr bgcolor="CCCCCC"><td width="130" bgcolor="FFFFFF">
				<font face="Verdana" color="000000" size="2"><b>UserName</b></font>
			</td><td>
				<input type="Text" name="UserName" size="45" maxlength="26" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr bgcolor="CCCCCC"><td width="130" bgcolor="FFFFFF">
				<font face="Verdana" color="000000" size="2"><b>Password</b></font>			
			</td><td>
				<input type="Password" name="Password" size="45" maxlength="26" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr bgcolor="CCCCCC"><td colspan="2">
				<center><input type="Submit" value="LOGIN" style="font-family: Verdana; width: 100%;"></center>
			</td></tr>
		</table>
	</td></tr>
</table>
	~;
	open(HTML,"./UltraRank.them") || &ShowScriptError("Couldn't open the UltraRank.them file");
		while (<HTML>) {
			if ($_=~/\<--ULTRARANK_TITLE--\>/) {
				$_=~s/\<--ULTRARANK_TITLE--\>/$Con{'SiteTitle'} - Login/g;
			}elsif ($_=~/\<--ULTRARANK_MAIN--\>/) {
				$_=~s/\<--ULTRARANK_MAIN--\>/$HTML/g;
			}
			print $_;
		}
	close(HTML);
	exit;
}

sub VerifyMember {
	if ((!$UltraRank::input{'UserName'})||(!$UltraRank::input{'Password'})) {
		&UltraRank::ShowError("LOGIN PROLBEM", "Invaild UserName and Password");
	}
	if (-e "$Con{'MembersPath'}/$UltraRank::input{'UserName'}.dat") {
		open(PASS,"$Con{'MembersPath'}/$UltraRank::input{'UserName'}.dat") || &ShowScriptError("Couldn't open the $UltraRank::input{'UserName'}.dat file");
			@INFO=split(/\|\^\|/,<PASS>);
			if ($UltraRank::input{'Password'} ne @INFO[4]) {
				&UltraRank::ShowError("LOGIN PROLBEM", "Invaild UserName and Password");
			}
		close(PASS);
	}else{
		&UltraRank::ShowError("LOGIN PROLBEM", "Invaild UserName and Password");
	}
}

sub Control {
	&VerifyMember;
	open(INFO,"$Con{'MembersPath'}/$UltraRank::input{'UserName'}.dat") || &ShowScriptError("Couldn't open the $UltraRank::input{'UserName'}.dat file");
		@INFO=split(/\|\^\|/,<INFO>);
	close(INFO);
	&UltraRank::PrintHTMLHeader;
	$HTML="";
	if ($_[0]) {
		$HTML.=qq~
<table width="$Con{'TableWidth'}" align="$Con{'TableAlign'}" border="0" cellspacing="0" cellpadding="0" bgcolor="$Con{'TableBordColor'}">
	<tr><td>
		<table width="100%" cellspacing="$Con{'TableSpac'}" cellpadding="$Con{'TablePad'}" background="$Con{'TableBG'}">
			<tr><td bgcolor="$Con{'TableHeaderColor'}"><font face="$Con{'TextFace'}" color="$Con{'HeaderTextColor'}" size="$Con{'HeaderTextSize'}"><b>$_[0]</b></font></td></tr>
		</table>
	</td></tr>
</table><p>
		~;
	}
	$HTML.=qq~
<table width="$Con{'TableWidth'}" align="$Con{'TableAlign'}" border="0" cellspacing="0" cellpadding="0" bgcolor="$Con{'TableBordColor'}">
	<tr><td>
		<table width="100%" cellspacing="$Con{'TableSpac'}" cellpadding="$Con{'TablePad'}" background="$Con{'TableBG'}">
			<tr bgcolor="$Con{'TableHeaderColor'}"><td colspan="4"><font face="$Con{'TextFace'}" color="$Con{'HeaderTextColor'}" size="$Con{'HeaderTextSize'}"><b>STATS</b></font></td></tr>
			<tr bgcolor="$Con{'TableColColor'}">
    			<td><font face="$Con{'TextFace'}" color="$Con{'TextColor'}" size="$Con{'TextSize'}"><b>Total Hits</b></font></td>
    			<td><font face="$Con{'TextFace'}" color="$Con{'TextColor'}" size="$Con{'TextSize'}"><b>Hits In</b></font></td>
				<td><font face="$Con{'TextFace'}" color="$Con{'TextColor'}" size="$Con{'TextSize'}"><b>Hits Out</b></font></td>
			</tr>
			<tr bgcolor="$Con{'TableBGColor'}">
    			<td><font face="$Con{'TextFace'}" color="$Con{'TextColor'}" size="$Con{'TextSize'}">@INFO[0]</font></td>
    			<td><font face="$Con{'TextFace'}" color="$Con{'TextColor'}" size="$Con{'TextSize'}">@INFO[1]</font></td>
				<td><font face="$Con{'TextFace'}" color="$Con{'TextColor'}" size="$Con{'TextSize'}">@INFO[2]</font></td>
			</tr>
		</table>
	</td></tr>
</table>
<form method=post action="$Con{'URLCGI'}/URAccount.pl">
<input type=hidden name="action" value="DoEditAccount">
<input type=hidden name="Password" value="$UltraRank::input{'Password'}">
<input type=hidden name="UserName" value="$UltraRank::input{'UserName'}">
<table width="$Con{'TableWidth'}" align="$Con{'TableAlign'}" border="0" cellspacing="0" cellpadding="0" bgcolor="$Con{'TableBordColor'}">
	<tr><td>
		<table width="100%" cellspacing="$Con{'TableSpac'}" cellpadding="$Con{'TablePad'}" background="$Con{'TableBG'}">
			<tr bgcolor="$Con{'TableHeaderColor'}"><td colspan="2"><font face="$Con{'TextFace'}" color="$Con{'HeaderTextColor'}" size="$Con{'HeaderTextSize'}"><b>MODIFY YOUR ACCOUNT</b></font></td></tr>
			<tr bgcolor="$Con{'TableBGColor'}"><td width="130" bgcolor="$Con{'TableColColor'}">
				<font face="$Con{'TextFace'}" color="$Con{'TextColor'}" size="$Con{'TextSize'}"><b>New Password</b></font>
			</td><td>
				<input type="Password" name="NewPassword" size="$Con{'TextFieldSize'}" value="$UltraRank::input{'Password'}" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr bgcolor="$Con{'TableBGColor'}"><td width="130" bgcolor="$Con{'TableColColor'}">
				<font face="$Con{'TextFace'}" color="$Con{'TextColor'}" size="$Con{'TextSize'}"><b>Verify New Password</b></font>
			</td><td>
				<input type="Password" name="VNewPassword" size="$Con{'TextFieldSize'}" value="$UltraRank::input{'Password'}" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr bgcolor="$Con{'TableBGColor'}"><td width="130" bgcolor="$Con{'TableColColor'}">
				<font face="$Con{'TextFace'}" color="$Con{'TextColor'}" size="$Con{'TextSize'}"><b>Email</b></font>
			</td><td>
				<input type="Text" name="Email" size="$Con{'TextFieldSize'}" value="@INFO[5]" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr bgcolor="$Con{'TableBGColor'}"><td width="130" bgcolor="$Con{'TableColColor'}">
				<font face="$Con{'TextFace'}" color="$Con{'TextColor'}" size="$Con{'TextSize'}"><b>Site Title</b></font>
			</td><td>
				<input type="Text" name="SiteTitle" size="$Con{'TextFieldSize'}" value="@INFO[6]" maxlength="40" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr bgcolor="$Con{'TableBGColor'}"><td width="130" bgcolor="$Con{'TableColColor'}">
				<font face="$Con{'TextFace'}" color="$Con{'TextColor'}" size="$Con{'TextSize'}"><b>Site Description</b></font>
			</td><td>
				<input type="Text" name="Description" size="$Con{'TextFieldSize'}" value="@INFO[7]" maxlength="255" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr bgcolor="$Con{'TableBGColor'}"><td width="130" bgcolor="$Con{'TableColColor'}">
				<font face="$Con{'TextFace'}" color="$Con{'TextColor'}" size="$Con{'TextSize'}"><b>Site URL</b></font>
			</td><td>
				<input type="Text" name="SiteURL" value="@INFO[8]" size="$Con{'TextFieldSize'}" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr bgcolor="$Con{'TableBGColor'}"><td width="130" bgcolor="$Con{'TableColColor'}">
				<font face="$Con{'TextFace'}" color="$Con{'TextColor'}" size="$Con{'TextSize'}"><b>Banner URL</b></font>
			</td><td>
				<input type="Text" name="BannerURL" value="@INFO[9]" size="$Con{'TextFieldSize'}" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr bgcolor="$Con{'TableBGColor'}"><td colspan="2">
				<center><input type="Submit" value="MODIFY YOUR ACCOUNT" style="font-family: Verdana; width: 100%;"></center>
			</td></tr>
		</table>
	</td></tr>
</table>
</form>
	~;
	open(HTML,"./UltraRank.them") || &ShowScriptError("Couldn't open the UltraRank.them file");
		while (<HTML>) {
			if ($_=~/\<--ULTRARANK_TITLE--\>/) {
				$_=~s/\<--ULTRARANK_TITLE--\>/$Con{'SiteTitle'} - Login/g;
			}elsif ($_=~/\<--ULTRARANK_MAIN--\>/) {
				$_=~s/\<--ULTRARANK_MAIN--\>/$HTML/g;
			}
			print $_;
		}
	close(HTML);
	exit;
}

###############################################################################
# DoEditAccount                                                               #
###############################################################################
sub DoEditAccount {
	&VerifyMember;
	&UltraRank::ShowError("FIELD PROBLEM", "You have left the 'NewPassword' field blank") unless ($UltraRank::input{'NewPassword'});
	&UltraRank::ShowError("FIELD PROBLEM", "You have left the 'Verify New Password' field blank") unless ($UltraRank::input{'VNewPassword'});
	&UltraRank::ShowError("FIELD PROBLEM", "You have left the 'Email' field blank") unless ($UltraRank::input{'Email'});
	&UltraRank::ShowError("FIELD PROBLEM", "You have left the 'Site Title' field blank") unless ($UltraRank::input{'SiteTitle'});
	&UltraRank::ShowError("FIELD PROBLEM", "You have left the 'Site Description' field blank") unless ($UltraRank::input{'Description'});
	&UltraRank::ShowError("FIELD PROBLEM", "You have left the 'Site URL' field blank") unless ($UltraRank::input{'SiteURL'});
	&UltraRank::ShowError("FIELD PROBLEM", "You have left the 'Banner URL' field blank") unless ($UltraRank::input{'BannerURL'});
	if (length($UltraRank::input{'NewPassword'})>26) {
		&UltraRank::ShowError("PASSWORD PROBLEM", "Your Password length is more than 26 characters");
	}
	if ($UltraRank::input{'NewPassword'}=~/\W/) {
		&UltraRank::ShowError("PASSWORD PROBLEM", "Your Password can't have any special characters in it");
	}
	if ($UltraRank::input{'NewPassword'} != $UltraRank::input{'VNewPassword'}) {
		&UltraRank::ShowError("PASSWORD PROBLEM", "Your Password and Verify Password are not match");
	}
	if ($UltraRank::input{'Email'}=~/[\!\#\$\%\^\&\*\(\)\{\}\;\:\'\`]/){
		&UltraRank::ShowError("EMAIL ADDRESS PROBLEM", "Your email can't have any special characters in it");
   	}
	if ($UltraRank::input{'Email'}!~/.*\@.*\..*/) {
		&UltraRank::ShowError("EMAIL ADDRESS PROBLEM", "Your email is wrong");
	}
	if (length($UltraRank::input{'SiteTitle'})>$Con{'MaxSubjectLength'}){
		&UltraRank::ShowError("SITE TITLE PROBLEM", "Your Site Title length is more than $Con{'MaxSubjectLength'} characters");
   	}
	if (length($UltraRank::input{'Description'})>$Con{'MaxDesLength'}){
		&UltraRank::ShowError("SITE DESCRIPTION PROBLEM", "Your Site Description length is more than $Con{'MaxDesLength'} characters");
   	}
	if ($UltraRank::input{'SiteURL'}!~/^http:\/\/[\w\d\-\.]+\.[\w\d\-\.]+/){
		&UltraRank::ShowError("SITE URL PROBLEM", "Your site URL is wrong");
   	}
	if ($UltraRank::input{'BannerURL'}!~/^http:\/\/[\w\d\-\.]+\.[\w\d\-\.]+/){
		&UltraRank::ShowError("BANNER URL PROBLEM", "Your banner URL is wrong");
   	}

	#Total Hits |^| Hits In |^| Hits Out |^| Time |^| Password |^| Email |^| Site Title |^| Site Description |^| Site URL |^| Banner URL |^| Last Click |^| Status
	open(FILE,"$Con{'MembersPath'}/$UltraRank::input{'UserName'}.dat") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the ".$UltraRank::input{'UserName'}.".dat file.");
		$MEMBER=<FILE>;
		chomp ($MEMBER);
		@INFO=split(/\|\^\|/, $MEMBER);
	close(FILE);
	@INFO[4]=crypt($UltraRank::input{'NewPassword'},"ab");
	@INFO[5]=$UltraRank::input{'Email'};
	@INFO[6]=$UltraRank::input{'SiteTitle'};
	@INFO[7]=$UltraRank::input{'Description'};
	@INFO[8]=$UltraRank::input{'SiteURL'};
	@INFO[9]=$UltraRank::input{'BannerURL'};
	open(FILE,">$Con{'MembersPath'}/$UltraRank::input{'UserName'}.dat") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the ".$UltraRank::input{'UserName'}.".dat file.");
		$LINE=join("\|\^\|", @INFO);
		print FILE $LINE."\n";
	close(FILE);
	&Control("MODIFED YOUR PROFILE");
}

###############################################################################
# DoAddMember                                                                 #
###############################################################################
sub DoAddMember {
	&UltraRank::ShowError("FIELD PROBLEM", "You have left the 'User Name' field blank") unless ($UltraRank::input{'UserName'});
	&UltraRank::ShowError("FIELD PROBLEM", "You have left the 'Password' field blank") unless ($UltraRank::input{'Password'});
	&UltraRank::ShowError("FIELD PROBLEM", "You have left the 'Verify Password' field blank") unless ($UltraRank::input{'VPassword'});
	&UltraRank::ShowError("FIELD PROBLEM", "You have left the 'Email' field blank") unless ($UltraRank::input{'Email'});
	&UltraRank::ShowError("FIELD PROBLEM", "You have left the 'Site Title' field blank") unless ($UltraRank::input{'SiteTitle'});
	&UltraRank::ShowError("FIELD PROBLEM", "You have left the 'Site Description' field blank") unless ($UltraRank::input{'Description'});
	&UltraRank::ShowError("FIELD PROBLEM", "You have left the 'Site URL' field blank") unless ($UltraRank::input{'SiteURL'});
	&UltraRank::ShowError("FIELD PROBLEM", "You have left the 'Banner URL' field blank") unless ($UltraRank::input{'BannerURL'});
	if (length($UltraRank::input{'UserName'})>26) {
		&UltraRank::ShowError("USERNAME PROBLEM", "Your Username length is more than 26 characters");
	}
	if ($UltraRank::input{'UserName'}=~/\W/) {
		&UltraRank::ShowError("USERNAME PROBLEM", "Your Username can't have any special characters in it");
	}
	if (length($UltraRank::input{'Password'})>26) {
		&UltraRank::ShowError("PASSWORD PROBLEM", "Your Password length is more than 26 characters");
	}
	if ($UltraRank::input{'Password'}=~/\W/) {
		&UltraRank::ShowError("PASSWORD PROBLEM", "Your Password can't have any special characters in it");
	}
	if ($UltraRank::input{'Password'} != $UltraRank::input{'VPassword'}) {
		&UltraRank::ShowError("PASSWORD PROBLEM", "Your Password and Verify Password are not match");
	}
	if ($UltraRank::input{'Email'}=~/[\!\#\$\%\^\&\*\(\)\{\}\;\:\'\`]/){
		&UltraRank::ShowError("EMAIL ADDRESS PROBLEM", "Your email can't have any special characters in it");
   	}
	if ($UltraRank::input{'Email'}!~/.*\@.*\..*/) {
		&UltraRank::ShowError("EMAIL ADDRESS PROBLEM", "Your email is wrong");
	}
	if (length($UltraRank::input{'SiteTitle'})>$Con{'MaxSubjectLength'}){
		&UltraRank::ShowError("SITE TITLE PROBLEM", "Your Site Title length is more than $Con{'MaxSubjectLength'} characters");
   	}
	if (length($UltraRank::input{'Description'})>$Con{'MaxDesLength'}){
		&UltraRank::ShowError("SITE DESCRIPTION PROBLEM", "Your Site Description length is more than $Con{'MaxDesLength'} characters");
   	}
	if ($UltraRank::input{'SiteURL'}!~/^http:\/\/[\w\d\-\.]+\.[\w\d\-\.]+/){
		&UltraRank::ShowError("SITE URL PROBLEM", "Your site URL is wrong");
   	}
	if ($UltraRank::input{'BannerURL'}!~/^http:\/\/[\w\d\-\.]+\.[\w\d\-\.]+/){
		&UltraRank::ShowError("BANNER URL PROBLEM", "Your banner URL is wrong");
   	}
	if(-e "$Con{'MembersPath'}/$UltraRank::input{'UserName'}.dat") { 
		&UltraRank::ShowError("USERNAME PROBLEM", "Your Username has taken");
	}
	if(-e "$Con{'DataPath'}/BanSite.dat") {
		open(BANSITE,"$Con{'DataPath'}/BanSite.dat") || &UltraRank::ShowScriptError("Coundn't open the BanSite.dat file");
			@BanSites=split(/\n/,<BANSITE>);
		close(BANSITE);
		for (@BanSites) {
			if ($UltraRank::input{'SiteURL'}=~/$_/gi) {
				&UltraRank::ShowError("SITE URL PROBLEM", "Your site URL has been banned");
			}
		}
	}
	if ($Con{'ReviewBeList'} eq "on") {
		open(MEMBER,">$Con{'MembersPath'}/$UltraRank::input{'UserName'}.rev") || &UltraRank::ShowScriptError("Coundn't create the $UltraRank::input{'UserName'}.dat file");
			#Total Hits |^| Hits In |^| Hits Out |^| Time |^| Password |^| Email |^| Site Title |^| Site Description |^| Site URL |^| Banner URL |^| Last Click |^| Status
			print MEMBER "0|^|0|^|0|^|".time."|^|".crypt($UltraRank::input{'Password'},"ab")."|^|$UltraRank::input{'Email'}|^|$UltraRank::input{'SiteTitle'}|^|$UltraRank::input{'Description'}|^|$UltraRank::input{'SiteURL'}|^|$UltraRank::input{'BannerURL'}|^|0|^|ACTIVE";
		close(MEMBER);
		chmod(0644, "$Con{'MembersPath'}/$UltraRank::input{'UserName'}.rev") || &UltraRank::ShowScriptError("Coundn't change the $UltraRank::input{'UserName'}.dat file");
		open(LOG,">$Con{'MembersPath'}/$UltraRank::input{'UserName'}.log") || &UltraRank::ShowScriptError("Coundn't create the $UltraRank::input{'UserName'}.log file");
		close(LOG);
		chmod(0666, "$Con{'MembersPath'}/$UltraRank::input{'UserName'}.log") || &UltraRank::ShowScriptError("Coundn't change the $UltraRank::input{'UserName'}.log file");
		$MailMessage=qq~A new member has signed up a account.\nYou can review this account in UltraRank Administrator Center.\n\n~;
		$MailMessage.=qq~$Con{'URLCGI'}/URAdmin.pl~;
		&UltraRank::SendMail($Con{'EMail'}, $Con{'EMail'}, "New Member", $MailMessage);
		$ThankMessage=qq~Your profile has been successfully stored, however we have to verify each submission.<br>~;
		$ThankMessage.=qq~As soon as your site has been approved, we'll be sent an e-mail informing you ~;
		$ThankMessage.=qq~of the URL to link to and other details you'll need to get listed.~;
		&UltraRank::ShowThank("Thank You", $ThankMessage, "$Con{'URLHTML'}/$Con{'ListFileName'}.$Con{'ListFileExt'}");
	}else{
		open(MEMBER,">$Con{'MembersPath'}/$UltraRank::input{'UserName'}.dat") || &UltraRank::ShowScriptError("Coundn't create the $UltraRank::input{'UserName'}.dat file");
			#Total Hits |^| Hits In |^| Hits Out |^| Time |^| Password |^| Email |^| Site Title |^| Site Description |^| Site URL |^| Banner URL |^| Last Click |^| Status
			print MEMBER "0|^|0|^|0|^|".time."|^|".crypt($UltraRank::input{'Password'},"ab")."|^|$UltraRank::input{'Email'}|^|$UltraRank::input{'SiteTitle'}|^|$UltraRank::input{'Description'}|^|$UltraRank::input{'SiteURL'}|^|$UltraRank::input{'BannerURL'}|^|0|^|ACTIVE";
		close(MEMBER);
		chmod(0644, "$Con{'MembersPath'}/$UltraRank::input{'UserName'}.dat") || &UltraRank::ShowScriptError("Coundn't change the $UltraRank::input{'UserName'}.dat file");
		open(LOG,">$Con{'MembersPath'}/$UltraRank::input{'UserName'}.log") || &UltraRank::ShowScriptError("Coundn't create the $UltraRank::input{'UserName'}.log file");
		close(LOG);
		chmod(0666, "$Con{'MembersPath'}/$UltraRank::input{'UserName'}.log") || &UltraRank::ShowScriptError("Coundn't change the $UltraRank::input{'UserName'}.log file");	
		open(EMAIL,"$Con{'DataPath'}/Welcome.dat") || &UltraRank::ShowScriptError("Coundn't change the Welcome.txt file");
			$MailMessage=<EMAIL>;
		close(EMAIL);
		$MailMessage.=qq~\n\nAdd these code your site:\n~;
		open(CODE,"$Con{'DataPath'}/Code.dat") || &UltraRank::ShowScriptError("Coundn't change the Code.txt file");
			$Code=<CODE>;
			$Code=~s/\<--ULTRARANK_LINK--\>/$Con{'URLCGI'}\/UltraRank.pl?action=in&ID=$UltraRank::input{'UserName'}/g;
		close(CODE);
		$MailMessage.=$Code;
		$MailMessage.=qq~\n\nYour User Name : $UltraRank::input{'UserName'}\nYour Password : $UltraRank::input{'Password'}\n\n~;
		$MailMessage.=qq~Modify Your Profile :\n$Con{'URLCGI'}/URAccount.pl?action=Modify&ID=$UltraRank::input{'UserName'}&Password=$UltraRank::input{'Password'}\n~;
		$MailMessage.=qq~Check Your Stats :\n$Con{'URLCGI'}/URAccount.pl?action=Stats&ID=$UltraRank::input{'UserName'}&Password=$UltraRank::input{'Password'}\n\n~;
		$MailMessage.=qq~$Con{'SiteTitle'}\n$Con{'URLHTML'}/$Con{'ListFileName'}.$Con{'ListFileExt'}~;
		&UltraRank::SendMail($Con{'EMail'}, $UltraRank::input{'Email'}, "Welcome Message from $Con{'SiteTitle'}", $MailMessage);
		$Code=~s/\</\&lt\;/g;
		$Code=~s/\>/\&gt\;/g;
		$ThankMessage=qq~Your profile has been successfully added.<br>Add these code to your site to get hits<br>$Code~;
		&UltraRank::ShowThank("$Con{'SiteTitle'} - Thank You", $ThankMessage, "$Con{'URLHTML'}/$Con{'ListFileName'}.$Con{'ListFileExt'}");
	}
	exit;
}
