#!/usr/bin/perl

###############################################################################
# URAdmin.pl                                                                  #
###############################################################################
# UltraRank Ver. 1.00b by UltraScripts.com                                    #
# Scripts written by Jacky W.W. Yung, WebMaster@UltraScripts.com              #
# Documents written by Jeff Bradbury, Glacier@UltraScripts.com                #
# Available from http://www.UltraScripts.com/UltraRank/                       #
# --------------------------------------------------------------------------- #
# PROGRAM NAME : UltraRank                                                    #
# VERSION : 1.00 Beta                                                         #
# LAST MODIFIED : 04/15/1999                                                  #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999 Jacky Yung. All Rights Reserved.                         #
#                                                                             #
# This program is free software; you can redistribute it and/or modify it     #
# under the terms of the GNU General Public License as published by the Free  #
# Software Foundation; either version 2 of the License, or (at your option)   #
# any later version.                                                          #
#                                                                             #
# This program is distributed in the hope that it will be useful, but WITHOUT #
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or       #
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for   #
# more details.                                                               #
#                                                                             #
# You should have received a copy of the GNU General Public License along'    #
# with this program; if not, write to the Free Software Foundation, Inc., 59  #
# Temple Place - Suite 330, Boston, MA  02111-1307, USA.                      #
###############################################################################

require "./UltraRank.var";
require "./UltraRank.lib";

&UltraRank::ParseForm;

if ($UltraRank::input{'action'} eq ""){
	&Login;
}elsif ($UltraRank::input{'action'} eq "MainMenu") {
	if ($UltraRank::input{'Password'}) {
		$UltraRank::input{'Password'}=crypt($UltraRank::input{'Password'}, "ab");
	}
	&MainMenu;
}elsif ($UltraRank::input{'action'} eq "ExeFunction") {
	if ($UltraRank::input{'ActType'} eq "Normal") {
		if ($UltraRank::input{'Function'} eq "SetVariables") {
			&SetVariables;
		}elsif ($UltraRank::input{'Function'} eq "ChangePassword") {
			&ChangePassword;
		}elsif ($UltraRank::input{'Function'} eq "SearchMembers") {
			&SearchMembers;
		}elsif ($UltraRank::input{'Function'} eq "SendEmail") {
			&SendEmail;
		}elsif ($UltraRank::input{'Function'} eq "AdsBreaks") {
			&AdsBreaks;
		}elsif ($UltraRank::input{'Function'} eq "BanSite") {
			&BanSite;
		}elsif ($UltraRank::input{'Function'} eq "DisplayError") {
			&DisplayError;
		}elsif ($UltraRank::input{'Function'} eq "ReList") {
			#require "$Con{'DataPath'}/Reset.dat";
			&UltraRank::ReList();
			&MainMenu("FINISHED RELIST");
		}else{
			&MainMenu;
		}
	}elsif ($UltraRank::input{'ActType'} eq "EditPage") {
		if ($UltraRank::input{'ModifyType'} eq "HTMLTemp") {
			&HTMLTemp;
		}elsif ($UltraRank::input{'ModifyType'} eq "TablePro") {
			&TablePro;
		}
	}elsif ($UltraRank::input{'ActType'} eq "EditFile") {
		if ($UltraRank::input{'ModifyFile2'} eq "EditWelcome") {
			&EditWelcome;
		}elsif ($UltraRank::input{'ModifyFile2'} eq "EditCode") {
			&EditCode;
		}elsif ($UltraRank::input{'ModifyFile2'} eq "EditGateway") {
			&EditGateway;
		}
	}else{
		&MainMenu;
	}
}elsif ($UltraRank::input{'action'} eq "UpdateVariables") {
	&UpdateVariables;
}elsif ($UltraRank::input{'action'} eq "DoChangePassword") {
	&DoChangePassword;
}elsif ($UltraRank::input{'action'} eq "BrowseMembers") {
	&BrowseMembers;
}elsif ($UltraRank::input{'action'} eq "DoBrowseAccounts") {
	if ($UltraRank::input{'SubmitType'} eq "MODIFY MEMBER ACCOUNT") {
		&ModifyMember;
	}elsif ($UltraRank::input{'SubmitType'} eq "DELETE MEMBERS ACCOUNT") {
		&DeleteMembers;
	}elsif ($UltraRank::input{'SubmitType'} eq "DEACTIVATE/ACTIVATE MEMBERS ACCOUNT") {
		&ActiveMembers;
	}
}elsif ($UltraRank::input{'action'} eq "DoEditMember") {
	&DoEditMember;
}elsif ($UltraRank::input{'action'} eq "ReviewMembers") {
	if ($UltraRank::input{'SubmitType'} eq "APPROVE") {
		&DoApprove;
	}elsif ($UltraRank::input{'SubmitType'} eq "DECLINE") {
		&DoDecline;
	}
}elsif ($UltraRank::input{'action'} eq "DoSendEmail") {
	&DoSendEmail;
}elsif ($UltraRank::input{'action'} eq "DoHTMLTemp") {
	&DoHTMLTemp;
}elsif ($UltraRank::input{'action'} eq "DoTablePro") {
	&DoTablePro;
}elsif ($UltraRank::input{'action'} eq "DoAdsBreaks") {
	&DoAdsBreaks;
}elsif ($UltraRank::input{'action'} eq "DoEditWelcome") {
	&DoEditWelcome;
}elsif ($UltraRank::input{'action'} eq "DoEditCode") {
	&DoEditCode;
}elsif ($UltraRank::input{'action'} eq "DoEditGateway") {
	&DoEditGateway;
}elsif ($UltraRank::input{'action'} eq "DoBanSite") {
	&DoBanSite;
}elsif ($UltraRank::input{'action'} eq "DoClearError") {
	&DoClearError;
}else{
	&Login;
}
exit;

###############################################################################
# Login                                                                       #
###############################################################################
sub Login {
	&UltraRank::PrintHTMLHeader;
	&PrintHTMLTop;
	print qq~
<form action="$Con{'URLCGI'}/URAdmin.pl" method="POST">
<input type=hidden name="action" value="MainMenu">
<center><table width="580" border="0" cellspacing="0" cellpadding="1" bgcolor="black">
	<tr><td>
		<table width="100%" border="0" cellspacing="1" cellpadding="5">
			<tr><td bgcolor="#0080FF"><font face="Arial" size="2" color="White"><b>ADMINISTRATOR LOGIN</b></font></td></tr>
			<tr><td bgcolor="silver">
				<font face="Arial" size="2" color="Black"><b>Password</b></font><br>
				<input type="Password" name="Password" style="font-family: Arial; width: 100%;" value="" size=45>
			</td></tr>
			<tr><td bgcolor="silver">
				<center><input type="Submit" value="LOGIN" style="font-family: Arial; width: 100%;"></center>
			</td></tr>
		</table>
	</td></tr>
</table></center>
</form>
	~;
	&PrintHTMLBottom;
	exit;
}

###############################################################################
# VerifyAdmin                                                                 #
###############################################################################
sub VerifyAdmin {
	open(PASS,"$Con{'DataPath'}/Admin.dat") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the administrator password file.");
		$RealPassword = <PASS>;
	close(PASS);

	if ($UltraRank::input{'Password'} ne $RealPassword) {
		&ShowAdminError("LOGIN PROBLEM", "Your administrative password are invalid.");
	}
}

###############################################################################
# MainMenu                                                                    #
###############################################################################
sub MainMenu {
	&VerifyAdmin;
	&UltraRank::PrintHTMLHeader;
	&PrintHTMLTop;
	if ($_[0]) {
		print qq~
<center><table width="580" border="0" cellspacing="0" cellpadding="1" bgcolor="black">
	<tr><td>
		<table width="100%" border="0" cellspacing="1" cellpadding="5">
			<tr><td bgcolor="#0080FF"><font face="Arial" size="2" color="White"><b>$_[0]</b></font></td></tr>
		</table>
	</td></tr>
</table></center>
		~;
	}
	print qq~
<form action="$Con{'URLCGI'}/URAdmin.pl" method="POST">
<input type=hidden name=action value="ExeFunction">
<input type=hidden name=Password value="$UltraRank::input{'Password'}">
<center><table width="580" border="0" cellspacing="0" cellpadding="1" bgcolor="black">
	<tr><td>
		<table width="100%" border="0" cellspacing="1" cellpadding="5">
			<tr><td bgcolor="#0080FF" colspan="2"><font face="Arial" size="2" color="White"><b>ADMINISTRATIVE FUNCTIONS</b></font></td></tr>
			<tr><td bgcolor="white"><input type="Radio" name="ActType" value="Normal" checked></td>
			<td bgcolor="silver" width="100%">
				<select name="Function" style="width: 100%;">
					<option value="SetVariables">Configure Variables</option>
	   				<option value="ChangePassword">Change Administrator Password</option>
					<option value="AdsBreaks">Modify Ads Breaks</option>
	   				<option value="SearchMembers">Search Members Account</option>
	   				<option value="SendEmail">Send Email to Members</option>
	   				<option value="BanSite">Ban a Site</option>
	   				<option value="DisplayError">Display Error Logs</option>
	   				<option value="ReList">ReRank The List</option>
				</select>
			</td></tr>
			<tr><td bgcolor="white"><input type="Radio" name="ActType" value="EditPage"></td>
			<td bgcolor="silver" width="100%">
				<table width="100%" border="0" cellspacing="0" cellpadding="0">
					<tr><td width="35%">
						<select name="ModifyType" style="width: 100%;">
							<option value="HTMLTemp">Modify HTML Template</option>
							<option value="TablePro">Modify Table Properties</option>
						</select>
					</td><td width="65%">
						<select name="ModifyFile" style="width: 100%;">
							<option value="ALL THE PAGES">For All the Pages</option>
							<option value="$Con{'ListFileName'}.$Con{'ListFileExt'}">For $Con{'ListFileName'}.$Con{'ListFileExt'}</option>
	~;
	for ($i=1;$i<$Con{'NumSitesPage'};$i++) {
		print qq~<option value="$Con{'ListFileName'}_$i.$Con{'ListFileExt'}">For $Con{'ListFileName'}_$i.$Con{'ListFileExt'}</option>\n~;
	}
	print qq~
						</select>
					</td></tr>
				</table>
			</td></tr>
			<tr><td bgcolor="white"><input type="Radio" name="ActType" value="EditFile"></td>
			<td bgcolor="silver" width="100%">
				<select name="ModifyFile2" style="width: 100%;">
					<option value="EditWelcome">Modify Welcome Email Message</option>
					<option value="EditCode">Modify The Code For Members</option>
	   				<option value="EditGateway">Modify Anti-Cheat Gateway Message</option>
				</select>
			</td></tr>
			<tr><td bgcolor="silver" colspan="2">
				<center><input type="Submit" value="EXECUTE FUNCTION" style="width: 100%;"></center>
			</td></tr>
		</table>
	</td></tr>
</table></center>
</form>
	~;
	if ($Con{'ReviewBeList'} eq "on") {
		opendir(MEMDIR,"$Con{'MembersPath'}") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the members directory.");
			@MembersFiles = sort(grep { m/.*\.rev/ }( readdir(MEMDIR)));
		closedir(MEMDIR);
		#Total Hits |^| Hits In |^| Hits Out |^| Time |^| Password |^| Email |^| Site Title |^| Site Description |^| Site URL |^| Banner URL |^| Last Click |^| Status
		print qq~
<form action="$Con{'URLCGI'}/URAdmin.pl" method="POST">
<input type=hidden name=action value="ReviewMembers">
<input type=hidden name=Password value="$UltraRank::input{'Password'}">
<center><table width="580" border="0" cellspacing="0" cellpadding="1" bgcolor="black">
	<tr><td>
		<table width="100%" border="0" cellspacing="1" cellpadding="5">
			<tr bgcolor="0080FF"><td colspan="4"><font face="Arial" color="FFFFFF" size="2"><b>REVIEW NEW MEMBERS</b></font></td></tr>
			<tr bgcolor="FFFFFF"><td width="20">
				&nbsp;
			</td><td>
				<font face="Verdana" color="000000" size="1"><b>ID</b></font>
			</td><td>
				<font face="Verdana" color="000000" size="1"><b>Email</b></font>
			</td><td>
				<font face="Verdana" color="000000" size="1"><b>Site Title</b></font>
			</td></tr>
		~;
		for ($i=0;$i<@MembersFiles;$i++) {
			@MembersFiles[$i]=~s/\n//g;
			open(INFO,"$Con{'MembersPath'}/".@MembersFiles[$i]) || &ShowAdminError("FILE PROBLEM", "Couldn't locate the ".@MembersFiles[$i]." file.");
				$INFO=<INFO>;
				chomp($INFO);
				@MemberInfo=split(/\|\^\|/,$INFO);
			close(INFO);
			@MembersFiles[$i]=~s/.rev//g;
			$FileUser=@MembersFiles[$i];
			print qq~
			<tr bgcolor="CCCCCC"><td>
				<input type="Checkbox" name="UserName$i" value="$FileUser">
			</td><td>
				<font face="Verdana" color="000000" size="1">$FileUser</font>			
			</td><td>
				<font face="Verdana" color="000000" size="1"><a href="mailto:@MemberInfo[5]">@MemberInfo[5]</a></font>			
			</td><td>
				<font face="Verdana" color="000000" size="1"><a href="$MemberInfo[8]">@MemberInfo[6]</a><br>@MemberInfo[7]</font>			
			</td></tr>
			~;
		}
		print qq~
			<tr><td bgcolor="silver" colspan="4">
				<table width="100%" cellspacing="0" cellpadding="0">
					<tr><td width="50%">
						<center><input type="Submit" name="SubmitType" value="APPROVE" style="width: 100%;"></center>
					</td><td width="50%">
						<center><input type="Submit" name="SubmitType" value="DECLINE" style="width: 100%;"></center>
					</td></tr>
				</table>
			</td></tr>
		</table>
	</td></tr>
</table></center>
<input type=hidden name=COUNT value="$i">
</form>
		~;
	}
	open(STAT,"$Con{'DataPath'}/Stats.dat") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the Stats.dat file.");
		@STATS=split(/\|\^\|/,<STAT>);
	close(STAT);
	opendir(MEMDIR,"$Con{'MembersPath'}") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the members directory.");
		@MembersFiles = sort(grep { m/.*\.dat/ }(readdir(MEMDIR)));
	closedir(MEMDIR);
	$Size=@MembersFiles;
	print qq~
<center><table width="580" border="0" cellspacing="0" cellpadding="1" bgcolor="black">
	<tr><td>
		<table width="100%" cellspacing="1" cellpadding="5" background="">
			<tr bgcolor="0080FF"><td colspan="4"><font face="Arial" color="FFFFFF" size="2"><b>STATS</b></font></td></tr>
			<tr bgcolor="CCCCCC">
    			<td bgcolor="FFFFFF"><font face="Verdana" color="000000" size="1"><b>Total Hits</b></font></td>
    			<td bgcolor="FFFFFF"><font face="Verdana" color="000000" size="1"><b>Hits In</b></font></td>
				<td bgcolor="FFFFFF"><font face="Verdana" color="000000" size="1"><b>Hits Out</b></font></td>
				<td bgcolor="FFFFFF"><font face="Verdana" color="000000" size="1"><b>Total Members</b></font></td>
			</tr>
			<tr bgcolor="CCCCCC">
    			<td><font face="Verdana" color="000000" size="2">@STATS[0]</font></td>
    			<td><font face="Verdana" color="000000" size="2">@STATS[1]</font></td>
				<td><font face="Verdana" color="000000" size="2">@STATS[2]</font></td>
				<td><font face="Verdana" color="000000" size="2">$Size</font></td>
			</tr>
		</table>
	</td></tr>
</table></center>
	~;
	open(DAYSTAT,"$Con{'DataPath'}/DayStats.dat") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the DayStats.dat file.");
		@DAYSTATS=<DAYSTAT>;
	close(DAYSTAT);
	$Size=@DAYSTATS;
	print qq~
<p>
<center><table width="580" border="0" cellspacing="0" cellpadding="1" bgcolor="black">
	<tr><td>
		<table width="100%" cellspacing="1" cellpadding="5" background="">
			<tr bgcolor="0080FF"><td colspan="6"><font face="Arial" color="FFFFFF" size="2"><b>STATS OF LAST 30 RESET</b></font></td></tr>
			<tr bgcolor="CCCCCC">
    			<td width="180" bgcolor="FFFFFF"><font face="Verdana" color="000000" size="1"><b>Date</b></font></td>
    			<td width="55" bgcolor="FFFFFF"><center><font face="Verdana" color="000000" size="1"><b>Hits In</b></font></center></td>
				<td width="55" bgcolor="FFFFFF"><center><font face="Verdana" color="000000" size="1"><b>Hits Out</b></font></center></td>
				
				<td width="180" bgcolor="FFFFFF"><font face="Verdana" color="000000" size="1"><b>Date</b></font></td>
    			<td width="55" bgcolor="FFFFFF"><center><font face="Verdana" color="000000" size="1"><b>Hits In</b></font></center></td>
				<td width="55" bgcolor="FFFFFF"><center><font face="Verdana" color="000000" size="1"><b>Hits Out</b></font></center></td>
			</tr>
	~;
	for ($i=0;$i<$Size;$i++) {
		@HitsInOut1=split(/\|\^\|/,@DAYSTATS[$i]);
		@HitsInOut1[0]=&UltraRank::CovDate(@HitsInOut1[0]);
		$i++;
		if (@DAYSTATS[$i]) {
			@HitsInOut2=split(/\|\^\|/,@DAYSTATS[$i]);
			@HitsInOut2[0]=&UltraRank::CovDate(@HitsInOut2[0]);
		}else{
			@HitsInOut2[0]="";
			@HitsInOut2[1]="";
			@HitsInOut2[2]="";
		}
		print qq~
			<tr bgcolor="CCCCCC">
    			<td width="200" bgcolor="FFFFFF"><font face="Verdana" color="000000" size="2"><b>@HitsInOut1[0]</b></font></td>
    			<td width="45"><center><font face="Verdana" color="000000" size="2">@HitsInOut1[1]</font></center></td>
				<td width="45"><center><font face="Verdana" color="000000" size="2">@HitsInOut1[2]</font></center></td>
				
				<td width="200" bgcolor="FFFFFF"><font face="Verdana" color="000000" size="2"><b>@HitsInOut2[0]</b></font></td>
    			<td width="45"><center><font face="Verdana" color="000000" size="2">@HitsInOut2[1]</font></center></td>
				<td width="45"><center><font face="Verdana" color="000000" size="2">@HitsInOut2[2]</font></center></td>
			</tr>
		~;
	}
	print qq~
		</table>
	</td></tr>
</table></center>
	~;
	&PrintHTMLBottom;
	exit;
}

###############################################################################
# DoApprove                                                                   #
###############################################################################
sub DoApprove {
	&VerifyAdmin;
	for ($i=0;$i<$UltraRank::input{'COUNT'};$i++) {
		if ($UltraRank::input{"UserName".$i}) {
			$UserName=$UltraRank::input{"UserName".$i};
			#Total Hits |^| Hits In |^| Hits Out |^| Time |^| Password |^| Email |^| Site Title |^| Site Description |^| Site URL |^| Banner URL |^| Last Click |^| Status
			open(INFO,"$Con{'MembersPath'}/$UserName.rev") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the $UserName.rev file.");
				$INFO=<INFO>;
				chomp($INFO);
				@MemberInfo=split(/\|\^\|/,$INFO);
			close(INFO);
			rename ("$Con{'MembersPath'}/$UserName.rev","$Con{'MembersPath'}/$UserName.dat");
			open(EMAIL,"$Con{'DataPath'}/Welcome.dat") || &UltraRank::ShowScriptError("Coundn't change the Welcome.dat file");
				$MailMessage=<EMAIL>;
			close(EMAIL);
			$MailMessage.=qq~\n\nAdd these code your site:\n~;
			open(CODE,"$Con{'DataPath'}/Code.dat") || &UltraRank::ShowScriptError("Coundn't change the Code.dat file");
				$Code=<CODE>;
				$Code=~s/\<--ULTRARANK_LINK--\>/$Con{'URLCGI'}\/UltraRank.pl?action=in&ID=$UserName/g;
			close(CODE);
			$MailMessage.=$Code;
			$MailMessage.=qq~\n\nYour User Name : $UserName\n\n~;
			$MailMessage.=qq~Modify Your Profile and Check Your Stats :\n$Con{'URLCGI'}/URAccount.pl\n~;
			$MailMessage.=qq~$Con{'SiteTitle'}\n$Con{'URLHTML'}/$Con{'ListFileName'}.$Con{'ListFileExt'}~;
			&UltraRank::SendMail($Con{'EMail'}, @MemberInfo[5], "Welcome Message from $Con{'SiteTitle'}", $MailMessage);
		}
	}
	&MainMenu("APPROVED MEMBERS");
}

###############################################################################
# DoDecline                                                                   #
###############################################################################
sub DoDecline {
	&VerifyAdmin;
	for ($i=0;$i<$UltraRank::input{'COUNT'};$i++) {
		if ($UltraRank::input{"UserName".$i}) {
			unlink("$Con{'MembersPath'}/".$UltraRank::input{"UserName".$i}.".rev");
			unlink("$Con{'MembersPath'}/".$UltraRank::input{"UserName".$i}.".log");
		}
	}
	&MainMenu("DECLINED MEMBERS");
}

###############################################################################
# SetVariables                                                                #
###############################################################################
sub SetVariables {
	&VerifyAdmin;
	if (-e "$Con{'DataPath'}/Rank.dat") {
		require "$Con{'DataPath'}/Rank.dat";
	}
	$DataPath=$Con{'DataPath'};
	$MembersPath=$Con{'MembersPath'};
	$HTMLPath=$Con{'HTMLPath'};
	$MailProg=$Con{'MailProg'};
	$URLCGI=$Con{'URLCGI'};
	$URLHTML=$Con{'URLHTML'};
	$SiteTitle=$Con{'SiteTitle'};
	$EMail=$Con{'EMail'};
	$ListFileName=$Con{'ListFileName'};

	$ListFileExt{'html'}="";
	$ListFileExt{'htm'}="";
	$ListFileExt{'shtml'}="";
	$ListFileExt{$Con{'ListFileExt'}}="selected";

	$NumSites=$Con{'NumSites'};
	$NumSitesPage=$Con{'NumSitesPage'};
	$NumSitesBreak=$Con{'NumSitesBreak'};

	$MinimumHits=$Con{'MinimumHits'};
	$MaxSubjectLength=$Con{'MaxSubjectLength'};
	$MaxDesLength=$Con{'MaxDesLength'};

	$TableWidth=$Con{'TableWidth'};

	$TableAlign="";
	$TableAlign="";
	$TableAlign{$Con{'TableAlign'}}="selected";

	$TableBordColor=$Con{'TableBordColor'};
	$TableSpac=$Con{'TableSpac'};
	$TablePad=$Con{'TablePad'};
	$TableBGColor=$Con{'TableBGColor'};
	$TableBG=$Con{'TableBG'};
	$TableHeaderColor=$Con{'TableHeaderColor'};
	$HeaderTextColor=$Con{'HeaderTextColor'};
	$HeaderTextSize=$Con{'HeaderTextSize'};
	$TableColColor=$Con{'TableColColor'};
	$TextFace=$Con{'TextFace'};
	$TextColor=$Con{'TextColor'};
	$TextSize=$Con{'TextSize'};
	$TextFieldSize=$Con{'TextFieldSize'};

	$LogErrors="";
	if ($Con{'LogErrors'} eq "on") {
		$LogErrors=" checked";
	}
	$AntiCheat="";
	if ($Con{'AntiCheat'} eq "on") {
		$AntiCheat=" checked";
	}
	$AgreeTerm="";
	if ($Con{'AgreeTerm'} eq "on") {
		$AgreeTerm=" checked";
	}
	$SendConfirm="";
	if ($Con{'SendConfirm'} eq "on") {
		$SendConfirm=" checked";
	}
	$ReviewBeList="";
	if ($Con{'ReviewBeList'} eq "on") {
		$ReviewBeList=" checked";
	}
	$UseLock="";
	if ($Con{'UseLock'} eq "on") {
		$UseLock=" checked";
	}
	$UseCron="";
	if ($Con{'UseCron'} eq "on") {
		$UseCron=" checked";
	}

	$TimeToReset=$Con{'TimeToReset'};
	$TimeToUpdate=$Con{'TimeToUpdate'};
	$BannerWidth=$Con{'BannerWidth'};
	$BannerHeight=$Con{'BannerHeight'};
	&UltraRank::PrintHTMLHeader;
	&PrintHTMLTop;
	print qq~
<form action="$Con{'URLCGI'}/URAdmin.pl" method="POST">
<input type=hidden name=action value="UpdateVariables">
<input type=hidden name=Password value="$UltraRank::input{'Password'}">
<center><table width="580" border="0" cellspacing="0" cellpadding="1" bgcolor="black">
	<tr><td>
		<table width="100%" border="0" cellspacing="1" cellpadding="5">
			<tr><td bgcolor="#0080FF" colspan="2"><font face="Arial" size="2" color="White"><b>CONFIGURE VARIABLES</b></font></td></tr>
			<tr><td bgcolor="white" width="100" valign="top">
				<font face="Arial" size="2" color="Black"><b>Absolute Paths</b></font>
			</td><td bgcolor="silver" width="480">
				<font face="Verdana" size="1" color="Black">
				<b>Directory Path of Data</b>
				<br><font size="1" color="Navy">The absolute directory path that where the data file will be located.<br>(ex. /home/yourdomain/cgi-bin/UltraRank/Data)</font>
				</font><br>
				<input type="Text" name="DataPath" value="$DataPath" style="font-family: Verdana; width: 100%;"><p>
				
				<font face="Verdana" size="1" color="Black">
				<b>Directory Path of Members</b>
				<br><font size="1" color="Navy">The absolute directory path that where the members data file will be located.<br>(ex. /home/yourdomain/cgi-bin/UltraRank/Data/members)</font>
				</font><br>
				<input type="Text" name="MembersPath" value="$MembersPath" style="font-family: Verdana; width: 100%;"><p>
				
				<font face="Verdana" size="1" color="Black">
				<b>Directory Path of HTML Lists</b>
				<br><font size="1" color="Navy">The absolute directory path that where the HTML list pages will be located.<br>(ex. /home/yourdomain/UltraRank)</font>
				</font><br>
				<input type="Text" name="HTMLPath" value="$HTMLPath" style="font-family: Verdana; width: 100%;"><p>
				
				<font face="Verdana" size="1" color="Black">
				<b>Absolute Path for SendMail Location</b>
				<br><font size="1" color="Navy">The location of the SendMail program.<br>(ex. /usr/sbin/sendmail)</font>
				</font><br>
				<input type="Text" name="MailProg" value="$MailProg" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr><td bgcolor="white" width="100" valign="top">
				<font face="Arial" size="2" color="Black"><b>URLs</b></font>
			</td><td bgcolor="silver" width="480">
				<font face="Verdana" size="1" color="Black">
				<b>CGI URL</b>
				<br><font size="1" color="Navy">The URL that where the UltraRank scripts located.<br>(ex. http://yourdomain/cgi-bin/UltraRank)</font>
				</font><br>
				<input type="Text" name="URLCGI" value="$URLCGI" style="font-family: Verdana; width: 100%;"><p>
				
				<font face="Verdana" size="1" color="Black">
				<b>HTML Lists URL</b>
				<br><font size="1" color="Navy">The URL that where the HTML list pages will be located.<br>(ex. http://yourdomain/UltraRank)</font>
				</font><br>
				<input type="Text" name="URLHTML" value="$URLHTML" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr><td bgcolor="white" width="100" valign="top">
				<font face="Arial" size="2" color="Black"><b>Lists Options</b></font>
			</td><td bgcolor="silver" width="480">
				<font face="Verdana" size="1" color="Black">
				<b>Site Title</b>
				<br><font size="1" color="Navy">The title of your top site list.</font>
				</font><br>
				<input type="Text" name="SiteTitle" value="$SiteTitle" style="font-family: Verdana; width: 100%;"><p>
				
				<font face="Verdana" size="1" color="Black">
				<b>E-Mail Address</b>
				<br><font size="1" color="Navy">Your e-mail address.</font>
				</font><br>
				<input type="Text" name="EMail" value="$EMail" style="font-family: Verdana; width: 100%;">
				<hr align="CENTER" width="100%">
				<table width="100%" border="0" cellspacing="0" cellpadding="0">
					<tr><td>
						<font face="Verdana" size="1"><b>Choose a filename and extension for your list pages:</b>
						<br><font size="1" color="Navy">The first HTML list page that will be print to?</font>
						</font><br>&nbsp;
					</td><td valign="top" width="130">
						<input type="Text" name="ListFileName" value="$ListFileName" size="7">
						<select name="ListFileExt">
							<option value="html"$ListFileExt{'html'}>.html</option>
	   						<option value="htm"$ListFileExt{'htm'}>.htm</option>
	   						<option value="shtml"$ListFileExt{'shtml'}>.shtml</option>
						</select></td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>How many sites do you want to ranked:</b>
						<br><font size="1" color="Navy">The total number of sites to be listed?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="NumSites" value="$NumSites" size="4" maxlength="4" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>How many pages to make the list:</b>
						<br><font size="1" color="Navy">The amount of HTML files to be used to make the list?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="NumSitesPage" value="$NumSitesPage" size="4" maxlength="4" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>After how many sites insert a break:</b>
						<br><font size="1" color="Navy">After how many site insert a break in the list?<br>(leave blank if none)</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="NumSitesBreak" value="$NumSitesBreak" size="4" maxlength="4" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Minimum Hits:</b>
						<br><font size="1" color="Navy">The minimum number of hits to get listed.</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="MinimumHits" value="$MinimumHits" size="4" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Site Title Max Length:</b>
						<br><font size="1" color="Navy">The maximum number of characters allowed for member site titles.</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="MaxSubjectLength" value="$MaxSubjectLength" size="3" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Site Description Max Length:</b>
						<br><font size="1" color="Navy">The maximum number of characters allowed for member site descriptions.</font>
						</font>
					</td><td valign="top">
						<input type="Text" name="MaxDesLength" value="$MaxDesLength" size="3" style="font-family: Verdana; width: 100%;">
					</td></tr>
				</table>
	~;
	for ($i=1;$i<5;$i++) {
		$ToNum=$Rank{"ToNum".$i};
		$ShowSiteName=$Rank{"ShowSiteName".$i};
		$ShowSiteBanner=$Rank{"ShowSiteBanner".$i};
		$ShowSiteDes=$Rank{"ShowSiteDes".$i};
		$SiteFontSize=$Rank{"SiteFontSize".$i};
		$SiteDesFontSize=$Rank{"SiteDesFontSize".$i};
		$SiteFontColor=$Rank{"SiteFontColor".$i};
		$BGColor=$Rank{"BGColor".$i};
		$Align=$Rank{"Align".$i};
		if ($ShowSiteName eq "on") {
			$ShowSiteName=" checked";
		}
		if ($ShowSiteBanner eq "on") {
			$ShowSiteBanner=" checked";
		}
		if ($ShowSiteDes eq "on") {
			$ShowSiteDes=" checked";
		}
		print qq~
				<hr align="CENTER" width="100%">
				<table width="100%" border="0" cellspacing="0" cellpadding="0">
					<tr><td>
						<font face="Verdana" size="1"><b>To </b></font><input type="Text" value="$ToNum" name="ToNum$i" size="4"><br>&nbsp;
					</td><td valign="top" width="130">
						&nbsp;
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Show Site Title:</b></font>
					</td><td valign="top">
						<input type="Checkbox" name="ShowSiteName$i"$ShowSiteName>
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Show Site Banner:</b></font>
					</td><td valign="top">
						<input type="Checkbox" name="ShowSiteBanner$i"$ShowSiteBanner>
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Show Site Description:</b></font>
					</td><td valign="top">
						<input type="Checkbox" name="ShowSiteDes$i"$ShowSiteDes>
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Font Size of Site Title:</b></font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" value="$SiteFontSize" name="SiteFontSize$i" size="1" maxlength="1" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Font Size of Site Description:</b></font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" value="$SiteDesFontSize" name="SiteDesFontSize$i" size="1" maxlength="1" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Font Color:</b></font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" value="$SiteFontColor" name="SiteFontColor$i" size="6" maxlength="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Background Color:</b></font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" value="$BGColor" name="BGColor$i" size="6" maxlength="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Align:</b></font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" value="$Align" name="Align$i" size="6" maxlength="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
				</table>
		~;
	}
	print qq~			
			</td></tr>
			<tr><td bgcolor="white" width="100" valign="top">
				<font face="Arial" size="2" color="Black"><b>Display Options<br><font size="1">(for non-list pages)</font></b></font>
			</td><td bgcolor="silver" width="480">
				<table width="100%" border="0" cellspacing="0" cellpadding="0">
					<tr><td>
						<font face="Verdana" size="1"><b>Table width:</b>
						<br><font size="1" color="Navy">The width value to use for table?</font>
						</font><br>&nbsp;
					</td><td valign="top" width="130">
						<input type="Text" name="TableWidth" value="$TableWidth" size="4" maxlength="4" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Table Align:</b>
						<br><font size="1" color="Navy">The align for table?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="TableAlign" value="$TableAlign" size="6" maxlength="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Table border color:</b>
						<br><font size="1" color="Navy">The border color to use for table?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="TableBordColor" value="$TableBordColor" size="6" maxlength="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Table cellspacing:</b>
						<br><font size="1" color="Navy">The cellspacing value to use for table?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="TableSpac" value="$TableSpac" size="2" maxlength="2" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Table cellpadding:</b>
						<br><font size="1" color="Navy">The cellpadding value to use for table?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="TablePad" value="$TablePad" size="2" maxlength="2" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Table bgcolor:</b>
						<br><font size="1" color="Navy">The background color to use for table?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="TableBGColor" value="$TableBGColor" size="6" maxlength="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Table background:</b>
						<br><font size="1" color="Navy">The background graphic to use for table?</font>
						</font>
					</td><td valign="top">
						<input type="Text" name="TableBG" value="$TableBG" size="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
				</table>
				<hr align="CENTER" width="100%">
				<table width="100%" border="0" cellspacing="0" cellpadding="0">
					<tr><td>
						<font face="Verdana" size="1"><b>Table header color:</b>
						<br><font size="1" color="Navy">The header color to use for table?</font>
						</font><br>&nbsp;
					</td><td valign="top" width="130">
						<input type="Text" name="TableHeaderColor" value="$TableHeaderColor" size="6" maxlength="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Header text color:</b>
						<br><font size="1" color="Navy">The header text color to use for table?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="HeaderTextColor" value="$HeaderTextColor" size="6" maxlength="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Header text size:</b>
						<br><font size="1" color="Navy">The header text size to use for table?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="HeaderTextSize" value="$HeaderTextSize" size="1" maxlength="1" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Table first column color:</b>
						<br><font size="1" color="Navy">The first column color to use for table?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="TableColColor" value="$TableColColor" size="6" maxlength="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Text face:</b>
						<br><font size="1" color="Navy">The text name which you use?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="TextFace" value="$TextFace" size="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Text color:</b>
						<br><font size="1" color="Navy">The normal text color to use for table?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="TextColor" value="$TextColor" size="6" maxlength="6" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Text size:</b>
						<br><font size="1" color="Navy">The normal text size to use for table?</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="TextSize" value="$TextSize" size="1" maxlength="1" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Text field size:</b>
						<br><font size="1" color="Navy">The text field size to use for table?</font>
						</font>
					</td><td valign="top">
						<input type="Text" name="TextFieldSize" value="$TextFieldSize" size="2" maxlength="2" style="font-family: Verdana; width: 100%;">
					</td></tr>
				</table>
			</td></tr>
			<tr><td bgcolor="white" width="100" valign="top">
				<font face="Arial" size="2" color="Black"><b>Miscellaneous Options</b></font>
			</td><td bgcolor="silver" width="480">
				<table width="100%" border="0" cellspacing="0" cellpadding="0">
					<tr><td valign="middle"><font face="Verdana" size="1"><b>Log Errors?</b></font></td>
					<td valign="top" width="130"><input type="Checkbox" name="LogErrors"$LogErrors></td></tr>
					<tr><td valign="middle"><font face="Verdana" size="1"><b>Use anti-cheat gateway?</b></font></td>
					<td valign="top" width="130"><input type="Checkbox" name="AntiCheat"$AntiCheat></td></tr>
					<tr><td valign="middle"><font face="Verdana" size="1"><b>Review new additions before listing?</b></font></td>
					<td valign="top" width="130"><input type="Checkbox" name="ReviewBeList"$ReviewBeList></td></tr>
					<tr><td valign="middle"><font face="Verdana" size="1"><b>Use FLock</b></font></td>
					<td valign="top" width="130"><input type="Checkbox" name="UseLock"$UseLock></td></tr>
				</table>
				<hr align="CENTER" width="100%">
				<table width="100%" border="0" cellspacing="0" cellpadding="0">
					<tr><td>
						<font face="Verdana" size="1"><b>Are you using crontabs to update the list:</b>
						<br><font size="1" color="Navy">Using crontabs to update the list?</font>
						</font><br>&nbsp;
					</td><td valign="top" width="130">
						<input type="Checkbox" name="UseCron"$UseCron>
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Reset time:</b>
						<br><font size="1" color="Navy">The number of seconds between reset?<br>(if you didn't use crontabs to update)</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="TimeToReset" value="$TimeToReset" size="4" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Rerank time:</b>
						<br><font size="1" color="Navy">The number of seconds between re-lists?<br>(if you didn't use crontabs to update)</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="TimeToUpdate" value="$TimeToUpdate" size="4" style="font-family: Verdana; width: 100%;">
					</td></tr>
				</table>
				<hr align="CENTER" width="100%">
				<table width="100%" border="0" cellspacing="0" cellpadding="0">
					<tr><td>
						<font face="Verdana" size="1"><b>Banner width:</b>
						<br><font size="1" color="Navy">The width value to use for all banners?<br>(if you want all the banners with same size)</font>
						</font><br>&nbsp;
					</td><td valign="top" width="130">
						<input type="Text" name="BannerWidth" value="$BannerWidth" size="4" style="font-family: Verdana; width: 100%;">
					</td></tr>
					<tr><td>
						<font face="Verdana" size="1"><b>Banner height:</b>
						<br><font size="1" color="Navy">The height value to use for all banners?<br>(if you want all the banners with same size)</font>
						</font><br>&nbsp;
					</td><td valign="top">
						<input type="Text" name="BannerHeight" value="$BannerHeight" size="4" style="font-family: Verdana; width: 100%;">
					</td></tr>
				</table>
			</td></tr>
			<tr><td bgcolor="silver" colspan="2">
				<center><input type="Submit" value="SAVE CONFIGURATION" style="font-family: Arial; width: 100%;"></center>
			</td></tr>
		</table>
	</td></tr>
</table></center>
</form>
	~;
	&PrintHTMLBottom;
	exit;
}

###############################################################################
# UpdateVariables                                                             #
###############################################################################
sub UpdateVariables {
	&VerifyAdmin;
	$UltraRank::input{'EMail'}=~s/\@/\\\@/g;
	open(VARS,">./UltraRank.var") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the variables file.");
		print VARS<<TEXT;
\$Con{'DataPath'}="$UltraRank::input{'DataPath'}";
\$Con{'MembersPath'}="$UltraRank::input{'MembersPath'}";
\$Con{'HTMLPath'}="$UltraRank::input{'HTMLPath'}";
\$Con{'MailProg'}="$UltraRank::input{'MailProg'}";
\$Con{'URLCGI'}="$UltraRank::input{'URLCGI'}";
\$Con{'URLHTML'}="$UltraRank::input{'URLHTML'}";
\$Con{'SiteTitle'}="$UltraRank::input{'SiteTitle'}";
\$Con{'EMail'}="$UltraRank::input{'EMail'}";
\$Con{'ListFileName'}="$UltraRank::input{'ListFileName'}";
\$Con{'ListFileExt'}="$UltraRank::input{'ListFileExt'}";
\$Con{'NumSites'}="$UltraRank::input{'NumSites'}";
\$Con{'NumSitesPage'}="$UltraRank::input{'NumSitesPage'}";
\$Con{'NumSitesBreak'}="$UltraRank::input{'NumSitesBreak'}";
\$Con{'RankBy'}="$UltraRank::input{'RankBy'}";
\$Con{'MinimumHits'}="$UltraRank::input{'MinimumHits'}";
\$Con{'MaxSubjectLength'}="$UltraRank::input{'MaxSubjectLength'}";
\$Con{'MaxDesLength'}="$UltraRank::input{'MaxDesLength'}";
\$Con{'TableWidth'}="$UltraRank::input{'TableWidth'}";
\$Con{'TableAlign'}="$UltraRank::input{'TableAlign'}";
\$Con{'TableBordColor'}="$UltraRank::input{'TableBordColor'}";
\$Con{'TableSpac'}="$UltraRank::input{'TableSpac'}";
\$Con{'TablePad'}="$UltraRank::input{'TablePad'}";
\$Con{'TableBGColor'}="$UltraRank::input{'TableBGColor'}";
\$Con{'TableBG'}="$UltraRank::input{'TableBG'}";
\$Con{'TableHeaderColor'}="$UltraRank::input{'TableHeaderColor'}";
\$Con{'HeaderTextColor'}="$UltraRank::input{'HeaderTextColor'}";
\$Con{'HeaderTextSize'}="$UltraRank::input{'HeaderTextSize'}";
\$Con{'TableColColor'}="$UltraRank::input{'TableColColor'}";
\$Con{'TextFace'}="$UltraRank::input{'TextFace'}";
\$Con{'TextColor'}="$UltraRank::input{'TextColor'}";
\$Con{'TextSize'}="$UltraRank::input{'TextSize'}";
\$Con{'TextFieldSize'}="$UltraRank::input{'TextFieldSize'}";
\$Con{'LogErrors'}="$UltraRank::input{'LogErrors'}";
\$Con{'AntiCheat'}="$UltraRank::input{'AntiCheat'}";
\$Con{'ReviewBeList'}="$UltraRank::input{'ReviewBeList'}";
\$Con{'UseLock'}="$UltraRank::input{'UseLock'}";
\$Con{'UseCron'}="$UltraRank::input{'UseCron'}";
\$Con{'TimeToReset'}="$UltraRank::input{'TimeToReset'}";
\$Con{'TimeToUpdate'}="$UltraRank::input{'TimeToUpdate'}";
\$Con{'BannerWidth'}="$UltraRank::input{'BannerWidth'}";
\$Con{'BannerHeight'}="$UltraRank::input{'BannerHeight'}";
1;
TEXT
	close(VARS);
	&UltraRank::PrintHTMLHeader;
	open(RANK,">$Con{'DataPath'}/Rank.dat") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the Rank.dat file.");
	for ($i=1;$i<5;$i++) {
$ToNum=$UltraRank::input{"ToNum".$i};
$ShowSiteName=$UltraRank::input{"ShowSiteName".$i};
$ShowSiteBanner=$UltraRank::input{"ShowSiteBanner".$i};
$ShowSiteDes=$UltraRank::input{"ShowSiteDes".$i};
$SiteFontSize=$UltraRank::input{"SiteFontSize".$i};
$SiteDesFontSize=$UltraRank::input{"SiteDesFontSize".$i};
$SiteFontColor=$UltraRank::input{"SiteFontColor".$i};
$BGColor=$UltraRank::input{"BGColor".$i};
$Align=$UltraRank::input{"Align".$i};
			print RANK<<TEXT;
\$Rank{'ToNum$i'}="$ToNum";
\$Rank{'ShowSiteName$i'}="$ShowSiteName";
\$Rank{'ShowSiteBanner$i'}="$ShowSiteBanner";
\$Rank{'ShowSiteDes$i'}="$ShowSiteDes";
\$Rank{'SiteFontSize$i'}="$SiteFontSize";
\$Rank{'SiteDesFontSize$i'}="$SiteDesFontSize";
\$Rank{'SiteFontColor$i'}="$SiteFontColor";
\$Rank{'BGColor$i'}="$BGColor";
\$Rank{'Align$i'}="$Align";
TEXT
	}
		print RANK "1;";
	close(RANK);
	unless(-e "$UltraRank::input{'DataPath'}/Reset.dat") {
		if(!$FUNCTIONS::FORM{'USING_CRON'}) {
			open(TIME, ">$UltraRank::input{'DataPath'}/Reset.dat") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the Reset.dat file.");
				$Time=time;
				print TIME "\$TIME{'ReListTime'}  = $Time;\n";
				print TIME "\$TIME{'ResetTime'} = $Time;\n";
				print TIME "1;";
			close(TIME);
			chmod(0666, "$UltraRank::input{'DataPath'}/Reset.dat");
		}
	}
	&MainMenu("SAVED CONFIGURATION");
}

###############################################################################
# ChangePassword                                                              #
###############################################################################
sub ChangePassword {
	&VerifyAdmin;
	&UltraRank::PrintHTMLHeader;
	&PrintHTMLTop;
	print qq~
<form action="$Con{'URLCGI'}/URAdmin.pl" method="POST">
<input type=hidden name="action" value="DoChangePassword">
<input type=hidden name=Password value="$UltraRank::input{'Password'}">
<center><table width="580" border="0" cellspacing="0" cellpadding="1" bgcolor="black">
	<tr><td>
		<table width="100%" cellspacing="1" cellpadding="5" background="">
			<tr bgcolor="0080FF"><td colspan="2"><font face="Arial" color="FFFFFF" size="2"><b>CHANGE PASSWORD</b></font></td></tr>
			<tr bgcolor="CCCCCC"><td width="130" bgcolor="FFFFFF">
				<font face="Verdana" color="000000" size="2"><b>New Password</b></font>			
			</td><td>
				<input type="Password" name="NewPassword" size="45" maxlength="26" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr bgcolor="CCCCCC"><td width="130" bgcolor="FFFFFF">
				<font face="Verdana" color="000000" size="2"><b>Verify New Password</b></font>
			</td><td>
				<input type="Password" name="NewVPassword" size="45" maxlength="26" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr bgcolor="CCCCCC"><td colspan="2">
				<center><input type="Submit" value="CHANGE PASSWORD" style="font-family: Verdana; width: 100%;"></center>
			</td></tr>
		</table>
	</td></tr>
</table></center>
</form>
	~;
	&PrintHTMLBottom;
	exit;
}

###############################################################################
# DoChangePassword                                                            #
###############################################################################
sub DoChangePassword {
	&VerifyAdmin;
	&UltraRank::ShowError("FIELD PROBLEM", "You have left the 'New Password' field blank") unless ($UltraRank::input{'NewPassword'});
	if (length($UltraRank::input{'NewPassword'})>26) {
		&UltraRank::ShowAdminError("PASSWORD PROBLEM", "Your Password length is more than 26 characters");
	}
	if ($UltraRank::input{'NewPassword'}=~/\W/) {
		&UltraRank::ShowAdminError("PASSWORD PROBLEM", "Your Password can't have any special characters in it");
	}
	if ($UltraRank::input{'NewPassword'} != $UltraRank::input{'NewVPassword'}) {
		&UltraRank::ShowAdminError("PASSWORD PROBLEM", "Your New Password and New Verify Password are not match");
	}
	&UltraRank::PrintHTMLHeader;
	open(PASS,">$Con{'DataPath'}/Admin.dat") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the administrator password file.");
		print PASS crypt($UltraRank::input{'NewPassword'}, "ab");
	close(PASS);
	&ShowAdminThank("CHANGED PASSWORD", "The new password have changed.<br>You will sent back to the administration page.", "URAdmin.pl");
}

###############################################################################
# SearchMembers                                                               #
###############################################################################
sub SearchMembers {
	&VerifyAdmin;
	&UltraRank::PrintHTMLHeader;
	&PrintHTMLTop;
	print qq~
<form action="$Con{'URLCGI'}/URAdmin.pl" method="POST">
<input type=hidden name=action value="BrowseMembers">
<input type=hidden name="Password" value="$UltraRank::input{'Password'}">
<center><table width="580" border="0" cellspacing="0" cellpadding="1" bgcolor="black">
	<tr><td>
		<table width="100%" cellspacing="1" cellpadding="5">
			<tr bgcolor="0080FF"><td colspan="2">
				<font face="Arial" color="FFFFFF" size="2"><b>SEARCH MEMBERS</b></font>
			</td></tr>
			<tr bgcolor="CCCCCC"><td width="130" bgcolor="FFFFFF">
				<font face="Verdana" color="000000" size="2"><b>UserName</b></font>
			</td><td>
				<input type="Text" name="SearchUserName" size="45" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr bgcolor="CCCCCC"><td width="130" bgcolor="FFFFFF">
				<font face="Verdana" color="000000" size="2"><b>Keyword</b></font>
			</td><td>
				<input type="Text" name="Keyword" size="45" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr bgcolor="CCCCCC"><td width="130" bgcolor="FFFFFF">
				<font face="Verdana" color="000000" size="2"><b>Function</b></font>
			</td><td>
				<select name="Function" style="font-family: Verdana; width: 100%;">
	   				<option value="Modify">Modify Member Account</option>
	   				<option value="Delete">Delete Members Account</option>
	   				<option value="Active">Deactivate/Activate Members Account</option>
				</select>
			</td></tr>
			<tr bgcolor="CCCCCC"><td colspan="2">
				<center><input type="Submit" value="SEARCH MEMBERS" style="font-family: Verdana; width: 100%;"></center>
			</td></tr>
		</table>
	</td></tr>
</table></center>
</form>
	~;
	&PrintHTMLBottom;
	exit;
}

###############################################################################
# BrowseMembers                                                               #
###############################################################################
sub BrowseMembers {
	&VerifyAdmin;
	&UltraRank::PrintHTMLHeader;
	opendir(MEMDIR,"$Con{'MembersPath'}") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the members directory.");
		@MembersFiles = sort(grep{m/.*\.dat/}(readdir(MEMDIR)));
	closedir(MEMDIR);
	$Size=@MembersFiles;
	$j=0;
	for($i=0;$i<$Size;$i++) {
		@MembersFiles[$i]=~s/\.dat//ig;
		if ((@MembersFiles[$i]=~/$UltraRank::input{'SearchUserName'}/ig)||(!$UltraRank::input{'SearchUserName'})) {
			open(MEMFILE, "$Con{'MembersPath'}/".@MembersFiles[$i].".dat") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the ".@MembersFiles[$i].".dat file.");
				$FILE=<MEMFILE>;
				if (($FILE=~/$UltraRank::input{'Keyword'}/ig)||(!$UltraRank::input{'Keyword'})) {
					@MEMBERINFO[$j] = $FILE;
					chomp(@MEMBERINFO[$j]);
					@MEMBERINFO[$j] .= "\|\^\|".@MembersFiles[$i];
					$j++;
				}
			close(MEMFILE);
		}
	}
	&PrintHTMLTop;
	if($UltraRank::input{'Function'} eq "Modify"){
		$SubmitName="MODIFY MEMBER ACCOUNT"
	}elsif($UltraRank::input{'Function'} eq "Delete"){
		$SubmitName="DELETE MEMBERS ACCOUNT"
	}elsif($UltraRank::input{'Function'} eq "Active"){
		$SubmitName="DEACTIVATE/ACTIVATE MEMBERS ACCOUNT"
	}
	print qq~
<form action="$Con{'URLCGI'}/URAdmin.pl" method="POST">
<input type=hidden name="SearchUserName" value="$UltraRank::input{'UserName'}">
<input type=hidden name="Keyword" value="$UltraRank::input{'Keyword'}">
<input type=hidden name="Function" value="$UltraRank::input{'Function'}">
<input type=hidden name="action" value="DoBrowseAccounts">
<input type=hidden name="Password" value="$UltraRank::input{'Password'}">
<center><table width="580" border="0" cellspacing="0" cellpadding="1" bgcolor="black">
	<tr><td>
		<table width="100%" cellspacing="1" cellpadding="5">
			<tr bgcolor="0080FF"><td colspan="8"><font face="Arial" color="FFFFFF" size="2"><b>$SubmitName</b></font></td></tr>
			<tr bgcolor="FFFFFF"><td width="20">
				&nbsp;
			</td><td>
				<font face="Verdana" color="000000" size="1"><b>ID</b></font>
			</td><td>
				<font face="Verdana" color="000000" size="1"><b>Site Title</b></font>
			</td><td width="30">
				<center><font face="Verdana" color="000000" size="1"><b>Total In</b></font></center>
			</td><td width="30">
				<center><font face="Verdana" color="000000" size="1"><b>In</b></font></center>
			</td><td width="30">
				<center><font face="Verdana" color="000000" size="1"><b>Out</b></font></center>
			</td><td width="50">
				<center><font face="Verdana" color="000000" size="1"><b>Last Click</b></font></center>
			</td><td width="50">
				<center><font face="Verdana" color="000000" size="1"><b>Status</b></font></center>
			</td></tr>
		~;
	$Size=@MEMBERINFO;
	for($i=0;$i<$Size;$i++){
		@Info=split(/\|\^\|/,@MEMBERINFO[$i]);
		#Total Hits |^| Hits In |^| Hits Out |^| Time |^| Password |^| Email |^| Site Title |^| Site Description |^| Site URL |^| Banner URL |^| Last Click |^| Status
		if($UltraRank::input{'Function'} eq "Modify"){
			$Select=qq~<input type="Radio" name="UserName" value="@Info[12]">~;
		}elsif($UltraRank::input{'Function'} eq "Delete"){
			$Select=qq~<input type="Checkbox" name="UserName$i" value="@Info[12]">~;
		}elsif($UltraRank::input{'Function'} eq "Active"){
			$Select=qq~<input type="Checkbox" name="UserName$i" value="@Info[12]">~;
		}
		if (!@Info[10]){
			$LastClick="N/A"
		}else{
			$LastClick=&UltraRank::CovDate(@Info[10]);
		}
		print qq~
			<tr bgcolor="CCCCCC"><td>
				$Select
			</td><td>
				<font face="Verdana" color="000000" size="1">@Info[12]</font>			
			</td><td>
				<font face="Verdana" color="000000" size="1"><a href="$Info[8]">@Info[6]</a></font>			
			</td><td>
				<font face="Verdana" color="000000" size="1"><CENTER>@Info[0]</CENTER></font>			
			</td><td>
				<font face="Verdana" color="000000" size="1"><CENTER>@Info[1]</CENTER></font>			
			</td><td>
				<font face="Verdana" color="000000" size="1"><CENTER>@Info[2]</CENTER></font>			
			</td><td>
				<font face="Verdana" color="000000" size="1"><center>$LastClick</center></font>			
			</td><td>
				<font face="Verdana" color="000000" size="1"><center>@Info[11]</center></font>			
			</td></tr>
		~;
	}
	print qq~
			<tr bgcolor="CCCCCC"><td colspan="8">
				<center><input type="Submit" name="SubmitType" value="$SubmitName" style="font-family: Verdana; width: 100%;"></center>
			</td></tr>
		</table>
	</td></tr>
</table></center>
<input type=hidden name="COUNT" value="$j">
</form>
	~;
	&PrintHTMLBottom;
	exit;
}

###############################################################################
# ModifyMember                                                                #
###############################################################################
sub ModifyMember {
	&VerifyAdmin;
	if (!$UltraRank::input{'UserName'}) {
		&ShowAdminError("PROBLEM", "No member have selected.")
	}
	#Total Hits |^| Hits In |^| Hits Out |^| Time |^| Password |^| Email |^| Site Title |^| Site Description |^| Site URL |^| Banner URL |^| Last Click |^| Status
	open(FILE,"$Con{'MembersPath'}/$UltraRank::input{'UserName'}.dat") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the ".$UltraRank::input{'UserName'}.".dat file.");
		$MEMBER=<FILE>;
		chomp ($MEMBER);
		@INFO=split(/\|\^\|/, $MEMBER);
	close(FILE);
	&UltraRank::PrintHTMLHeader;
	&PrintHTMLTop;
	print qq~
<form method=post action="$Con{'URLCGI'}/URAdmin.pl">
<input type=hidden name="SearchUserName" value="$UltraRank::input{'SearchUserName'}">
<input type=hidden name="Keyword" value="$UltraRank::input{'Keyword'}">
<input type=hidden name="Function" value="$UltraRank::input{'Function'}">
<input type=hidden name="action" value="DoEditMember">
<input type=hidden name="Password" value="$UltraRank::input{'Password'}">
<input type=hidden name="UserName" value="$UltraRank::input{'UserName'}">
<table width="580" align="center" border="0" cellspacing="0" cellpadding="1" bgcolor="000000">
	<tr><td>
		<table width="100%" cellspacing="1" cellpadding="5" background="">
			<tr bgcolor="0080FF"><td colspan="2"><font face="Arial" color="FFFFFF" size="2"><b>MODIFY MEMBER ACCOUNT ($UltraRank::input{'UserName'})</b></font></td></tr>
			<tr bgcolor="CCCCCC"><td width="130" bgcolor="FFFFFF">
				<font face="Verdana" color="000000" size="2"><b>Email</b></font>
			</td><td>
				<input type="Text" name="Email" size="45" value="@INFO[5]" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr bgcolor="CCCCCC"><td width="130" bgcolor="FFFFFF">
				<font face="Verdana" color="000000" size="2"><b>Site Title</b></font>
			</td><td>
				<input type="Text" name="SiteTitle" size="45" value="@INFO[6]" maxlength="40" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr bgcolor="CCCCCC"><td width="130" bgcolor="FFFFFF">
				<font face="Verdana" color="000000" size="2"><b>Site Description</b></font>
			</td><td>
				<input type="Text" name="Description" size="45" value="@INFO[7]" maxlength="255" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr bgcolor="CCCCCC"><td width="130" bgcolor="FFFFFF">
				<font face="Verdana" color="000000" size="2"><b>Site URL</b></font>
			</td><td>
				<input type="Text" name="SiteURL" value="@INFO[8]" size="45" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr bgcolor="CCCCCC"><td width="130" bgcolor="FFFFFF">
				<font face="Verdana" color="000000" size="2"><b>Banner URL</b></font>
			</td><td>
				<input type="Text" name="BannerURL" value="@INFO[9]" size="45" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr bgcolor="CCCCCC"><td colspan="2">
				<center><input type="Submit" value="MODIFY MEMBER ACCOUNT" style="font-family: Verdana; width: 100%;"></center>
			</td></tr>
		</table>
	</td></tr>
</table>
</form>
	~;
	&PrintHTMLBottom;
	exit;
}

###############################################################################
# DoEditMember                                                                #
###############################################################################
sub DoEditMember {
	&VerifyAdmin;
	&UltraRank::ShowError("FIELD PROBLEM", "You have left the 'Email' field blank") unless ($UltraRank::input{'Email'});
	&UltraRank::ShowError("FIELD PROBLEM", "You have left the 'Site Title' field blank") unless ($UltraRank::input{'SiteTitle'});
	&UltraRank::ShowError("FIELD PROBLEM", "You have left the 'Site Description' field blank") unless ($UltraRank::input{'Description'});
	&UltraRank::ShowError("FIELD PROBLEM", "You have left the 'Site URL' field blank") unless ($UltraRank::input{'SiteURL'});
	&UltraRank::ShowError("FIELD PROBLEM", "You have left the 'Banner URL' field blank") unless ($UltraRank::input{'BannerURL'});
	if ($UltraRank::input{'Email'}=~/[\!\#\$\%\^\&\*\(\)\{\}\;\:\'\`]/){
		&UltraRank::ShowError("EMAIL ADDRESS PROBLEM", "The email can't have any special characters in it");
   	}
	if ($UltraRank::input{'Email'}!~/.*\@.*\..*/) {
		&UltraRank::ShowError("EMAIL ADDRESS PROBLEM", "The email is wrong");
	}
	if (length($UltraRank::input{'SiteTitle'})>$Con{'MaxSubjectLength'}){
		&UltraRank::ShowError("SITE TITLE PROBLEM", "The Site Title length is more than $Con{'MaxSubjectLength'} characters");
   	}
	if (length($UltraRank::input{'Description'})>$Con{'MaxDesLength'}){
		&UltraRank::ShowError("SITE DESCRIPTION PROBLEM", "The Site Description length is more than $Con{'MaxDesLength'} characters");
   	}
	if ($UltraRank::input{'SiteURL'}!~/^http:\/\/[\w\d\-\.]+\.[\w\d\-\.]+/){
		&UltraRank::ShowError("SITE URL PROBLEM", "The site URL is wrong");
   	}
	if ($UltraRank::input{'BannerURL'}!~/^http:\/\/[\w\d\-\.]+\.[\w\d\-\.]+/){
		&UltraRank::ShowError("BANNER URL PROBLEM", "The banner URL is wrong");
   	}
	
	#Total Hits |^| Hits In |^| Hits Out |^| Time |^| Password |^| Email |^| Site Title |^| Site Description |^| Site URL |^| Banner URL |^| Last Click |^| Status
	open(FILE,"$Con{'MembersPath'}/$UltraRank::input{'UserName'}.dat") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the ".$UltraRank::input{'UserName'}.".dat file.");
		$MEMBER=<FILE>;
		chomp ($MEMBER);
		@INFO=split(/\|\^\|/, $MEMBER);
	close(FILE);
	@INFO[5]=$UltraRank::input{'Email'};
	@INFO[6]=$UltraRank::input{'SiteTitle'};
	@INFO[7]=$UltraRank::input{'Description'};
	@INFO[8]=$UltraRank::input{'SiteURL'};
	@INFO[9]=$UltraRank::input{'BannerURL'};
	open(FILE,">$Con{'MembersPath'}/$UltraRank::input{'UserName'}.dat") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the ".$UltraRank::input{'UserName'}.".dat file.");
		$LINE=join("\|\^\|", @INFO);
		print FILE $LINE."\n";
	close(FILE);
	&MainMenu("MODIFIED MEMBER ACCOUNT");
}

###############################################################################
# DeleteMembers                                                               #
###############################################################################
sub DeleteMembers {
	&VerifyAdmin;
	for($i=0;$i<$UltraRank::input{'COUNT'};$i++){
		if ($UltraRank::input{'UserName$i'}) {
			unlink("$Con{'MembersPath'}/".$UltraRank::input{"UserName".$i}.".dat");
		}
	}
	&MainMenu("DELETED MEMBERS ACCOUNT");
}

###############################################################################
# ActiveMembers                                                               #
###############################################################################
sub ActiveMembers {
	&VerifyAdmin;
	for($i=0;$i<$UltraRank::input{'COUNT'};$i++){
		if ($UltraRank::input{"UserName".$i}) {
			open(FILE,"$Con{'MembersPath'}/".$UltraRank::input{"UserName".$i}.".dat") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the ".$UltraRank::input{"UserName".$i}.".dat file.");
				$MEMBER=<FILE>;
				chomp ($MEMBER);
				@INFO=split(/\|\^\|/, $MEMBER);
			close(FILE);
			if (@INFO[11] eq "ACTIVE") {
				@INFO[11] = "DEACTIVE";
			}else{
				@INFO[11] = "ACTIVE";
			}
			open(FILE,">$Con{'MembersPath'}/".$UltraRank::input{"UserName".$i}.".dat") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the ".$UltraRank::input{"UserName".$i}.".dat file.");
				$LINE=join("\|\^\|", @INFO);
				print FILE $LINE."\n";
			close(FILE);
		}
	}
	&MainMenu("DE/ACTIVED MEMBERS ACCOUNT");
}

###############################################################################
# SendEmail                                                                   #
###############################################################################
sub SendEmail {
	&VerifyAdmin;
	&UltraRank::PrintHTMLHeader;
	&PrintHTMLTop;
	print qq~
<form method=post action="URAdmin.pl">
<input type=hidden name="action" value="DoSendEmail">
<input type=hidden name="Password" value="$UltraRank::input{'Password'}">
<table width="580" align="center" border="0" cellspacing="0" cellpadding="1" bgcolor="000000">
	<tr><td>
		<table width="100%" cellspacing="1" cellpadding="5" background="">
			<tr bgcolor="0080FF"><td colspan="2"><font face="Arial" color="FFFFFF" size="2"><b>SEND EMAIL TO ALL MEMBERS</b></font></td></tr>
			<tr bgcolor="CCCCCC"><td width="130" bgcolor="FFFFFF">
				<font face="Verdana" color="000000" size="2"><b>To</b></font>
			</td><td>
				<font face="Verdana" color="000000" size="2"><b>All Members</b></font>
			</td></tr>
			<tr bgcolor="CCCCCC"><td width="130" bgcolor="FFFFFF">
				<font face="Verdana" color="000000" size="2"><b>From</b></font>			
			</td><td>
				<font face="Verdana" color="000000" size="2"><b>$Con{'EMail'}</b></font>
			</td></tr>
			<tr bgcolor="CCCCCC"><td width="130" bgcolor="FFFFFF">
				<font face="Verdana" color="000000" size="2"><b>Subject</b></font>
			</td><td>
				<input type="Text" name="Subject" size="45" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr bgcolor="CCCCCC"><td width="130" bgcolor="FFFFFF" valign="top">
				<font face="Verdana" color="000000" size="2"><b>Message</b></font>
			</td><td>
				<textarea name="Message" cols="45" rows="15" style="font-family: Verdana; width: 100%;"></textarea>
			</td></tr>
			
			<tr bgcolor="CCCCCC"><td colspan="2">
				<center><input type="Submit" value="SEND EMAIL" style="font-family: Verdana; width: 100%;"></center>
			</td></tr>
		</table>
	</td></tr>
</table>
</form>
	~;
	&PrintHTMLBottom;
	exit;
}

###############################################################################
# DoSendEmail                                                                 #
###############################################################################
sub DoSendEmail {
	&VerifyAdmin;
	@MembersFiles=[];
	opendir(MEMDIR,"$Con{'MembersPath'}") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the members directory.");
		@MembersFiles = sort(grep{ m/.*\.dat/}(readdir(MEMDIR)));
	closedir(MEMDIR);
	for (@MembersFiles) {
		open(INFO,"$Con{'MembersPath'}/$_") || &ShowAdminError("FILE PROBLEM", "Couldn't locate the $_ file.");
			$INFO=<INFO>;
			chomp ($INFO);
			@MEMBERINFO=split(/\|\^\|/,$INFO);
		close(INFO);
		open (MAIL, "|$Con{'MailProg'} -t") || &ShowAdminError("Couldn't open the SendMail program");
			print MAIL <<EMAIL;
To: $MEMBERINFO[5]
From: $Con{'Email'}
Subject: $UltraRank::input{'Subject'}

$UltraRank::input{'Message'}

EMAIL
		close (MAIL);
	}
	&MainMenu("SENDED EMAIL");
}

###############################################################################
# BanSite                                                                     #
###############################################################################
sub BanSite {
	&VerifyAdmin;
	&UltraRank::PrintHTMLHeader;
	&PrintHTMLTop;
	open(BAN,"$Con{'DataPath'}/BanSite.dat");
		@BAN=<BAN>;
	close(BAN);
	print qq~
<form method=post action="URAdmin.pl">
<input type=hidden name="action" value="DoBanSite">
<input type=hidden name="Password" value="$UltraRank::input{'Password'}">
<table width="580" align="center" border="0" cellspacing="0" cellpadding="1" bgcolor="000000">
	<tr><td>
		<table width="100%" cellspacing="1" cellpadding="5" background="">
			<tr bgcolor="0080FF"><td><font face="Arial" color="FFFFFF" size="2"><b>BAN SITES</b></font></td></tr>
			<tr bgcolor="CCCCCC"><td bgcolor="FFFFFF">
				<font face="Verdana" color="000000" size="2"><b>
				Sperate sites by enter.
				</b></font>
			</td></tr>
			<tr bgcolor="CCCCCC"><td>
	~;
	print qq~<textarea name="BAN" cols="45" rows="15" style="font-family: Arial; width: 100%;" wrap="off">~;
	$Size=@BAN;
	for (@BAN) {
		print $_;
	}
	print qq~</textarea>~;
	print qq~
			</td></tr>
			<tr bgcolor="CCCCCC"><td>
				<center><input type="Submit" value="BAN SITES" style="font-family: Verdana; width: 100%;"></center>
			</td></tr>
		</table>
	</td></tr>
</table>
</form>
	~;
	&PrintHTMLBottom;
	exit;
}

###############################################################################
# DoBanSite                                                                   #
###############################################################################
sub DoBanSite {
	&VerifyAdmin;
	$UltraRank::input{'BAN'}=~s/\n/\n\n/g;
	open(BAN,">$Con{'DataPath'}/BanSite.dat") || &ShowAdminError("FILE PROBLEM", "Couldn't create/write the BanSite.dat file.");
		print BAN $UltraRank::input{'BAN'};
	close(BAN);
	&MainMenu("SAVED BAN SITES");
}

###############################################################################
# DisplayError                                                                #
###############################################################################
sub DisplayError {
	&VerifyAdmin;
	open(LOGS,"$Con{'DataPath'}/Errors.log") || &ShowAdminError("FILE PROBLEM", "Couldn't open the Errors.log file.");
		@Logs=<LOGS>;
	close(LOGS);
	&UltraRank::PrintHTMLHeader;
	&PrintHTMLTop;
	print qq~
<form action="$Con{'URLCGI'}/URAdmin.pl" method="POST">
<input type=hidden name="action" value="DoClearError">
<input type=hidden name="Password" value="$UltraRank::input{'Password'}">
<center><table width="580" border="0" cellspacing="0" cellpadding="1" bgcolor="black">
	<tr><td>
		<table width="100%" cellspacing="1" cellpadding="5">
			<tr bgcolor="0080FF"><td colspan="4"><font face="Arial" color="FFFFFF" size="2"><b>ERROR LOGS</b></font></td></tr>
			<tr bgcolor="FFFFFF"><td>
				<font face="Verdana" color="000000" size="1"><b>Date</b></font>
			</td><td>
				<font face="Verdana" color="000000" size="1"><b>IP</b></font>
			</td><td width="30">
				<center><font face="Verdana" color="000000" size="1"><b>Title</b></font></center>
			</td><td width="30">
				<center><font face="Verdana" color="000000" size="1"><b>Message</b></font></center>
			</td></tr>
		~;
	$Size=@Logs;
	for($i=0;$i<$Size;$i++){
		chomp(@Logs[$i]);
		@Info=split(/ \| /,@Logs[$i]);
		$Date=&UltraRank::CovDate(@Info[0]);
		print qq~
			<tr bgcolor="CCCCCC"><td>
				<font face="Verdana" color="000000" size="1">$Date</font>			
			</td><td>
				<font face="Verdana" color="000000" size="1">@Info[1]</font>			
			</td><td>
				<font face="Verdana" color="000000" size="1">@Info[2]</font>			
			</td><td>
				<font face="Verdana" color="000000" size="1">@Info[3]</font>			
			</td></tr>
		~;
	}
	print qq~
			<tr bgcolor="CCCCCC"><td colspan="4">
				<center><input type="Submit" name="SubmitType" value="CLEAN" style="font-family: Verdana; width: 100%;"></center>
			</td></tr>
		</table>
	</td></tr>
</table></center>
</form>
	~;
	&PrintHTMLBottom;
	exit;
}
###############################################################################
# DoClearError                                                                #
###############################################################################
sub DoClearError {
	&VerifyAdmin;
	open(LOGS,">$Con{'DataPath'}/Errors.log") || &ShowAdminError("FILE PROBLEM", "Couldn't create/write the Errors.log file.");
	close(LOGS);
	&MainMenu("CLEANED ERROR LOGS");
}

###############################################################################
# HTMLTemp                                                                    #
###############################################################################
sub HTMLTemp {
	&VerifyAdmin;
	&UltraRank::PrintHTMLHeader;
	&PrintHTMLTop;
	$HTMLTitle=$UltraRank::input{'ModifyFile'};
	$PageNum=$UltraRank::input{'ModifyFile'};
	$PageNum=~s/$Con{'ListFileName'}//g;
	$PageNum=~s/$Con{'ListFileExt'}//g;
	$PageNum=~s/\.//g;
	if ($PageNum eq "") {
		$PageNum=0;
	}
	$FileName=$Con{'ListFileName'}."_$PageNum.them";
	uc ($HTMLTitle);
	if ($UltraRank::input{'ModifyFile'} eq "ALL THE PAGES") {
		if (-e "$Con{'DataPath'}/HTMLList.them") {
			open(HTML,"$Con{'DataPath'}/HTMLList.them") || &ShowAdminError("FILE PROBLEM", "Couldn't open the HTMLList.them file.");
				@HTML=<HTML>;
			close(HTML);
		}else{
			open(HTML,"UltraRank.them") || &ShowAdminError("FILE PROBLEM", "Couldn't open the UltraRank.them file.");
				@HTML=<HTML>;
			close(HTML);
		}
	}else{
		if (-e "$Con{'DataPath'}/$FileName") {
			open(HTML,"$Con{'DataPath'}/$FileName") || &ShowAdminError("FILE PROBLEM", "Couldn't open the $FileName file.");
				@HTML=<HTML>;
			close(HTML);
		}else{
			open(HTML,"UltraRank.them") || &ShowAdminError("FILE PROBLEM", "Couldn't open the UltraRank.them file.");
				@HTML=<HTML>;
			close(HTML);
		}
	}
	print qq~
<form method=post action="URAdmin.pl">
<input type=hidden name="action" value="DoHTMLTemp">
<input type=hidden name="Password" value="$UltraRank::input{'Password'}">
<input type=hidden name="ModifyFile" value="$UltraRank::input{'ModifyFile'}">
<input type=hidden name="PageNum" value="$PageNum">
<table width="580" align="center" border="0" cellspacing="0" cellpadding="1" bgcolor="000000">
	<tr><td>
		<table width="100%" cellspacing="1" cellpadding="5" background="">
			<tr bgcolor="0080FF"><td><font face="Arial" color="FFFFFF" size="2"><b>EDIT HTML TEMPLATE FILE FOR $HTMLTitle</b></font></td></tr>
			<tr bgcolor="CCCCCC"><td bgcolor="FFFFFF">
				<font face="Verdana" color="000000" size="2"><b>
				Put <font color="Red"><--ULTRARANK_TITLE--></font> in HTML template that where the title of the page.<br>
				Put <font color="Red"><--ULTRARANK_MAIN--></font> in HTML template that where the body of the page.
				</b></font>
			</td></tr>
			<tr bgcolor="CCCCCC"><td>
	~;
	print qq~<textarea name="HTML" cols="45" rows="25" style="font-family: Arial; width: 100%;" wrap="off">~;
	$Size=@HTML;
	for (@HTML) {
		print $_;
	}
	print qq~</textarea>~;
	print qq~
			</td></tr>
			<tr bgcolor="CCCCCC"><td>
				<center><input type="Submit" value="SAVE HTML TEMPLATE FILE" style="font-family: Verdana; width: 100%;"></center>
			</td></tr>
		</table>
	</td></tr>
</table>
</form>
	~;
	&PrintHTMLBottom;
	exit;
}

###############################################################################
# DoHTMLTemp                                                                  #
###############################################################################
sub DoHTMLTemp {
	&VerifyAdmin;
	if ($UltraRank::input{'HTML'}!~/\<--ULTRARANK_TITLE--\>/) {
		&ShowAdminError("TEMPLATE PROBLEM", "Miss the \"\<--ULTRARANK_TITLE--\>\" code in the html template.");
	}
	if ($UltraRank::input{'HTML'}!~/\<--ULTRARANK_MAIN--\>/) {
		&ShowAdminError("TEMPLATE PROBLEM", "Miss the \"\<--ULTRARANK_MAIN--\>\" code in the html template.");
	}
	if ($UltraRank::input{'ModifyFile'} eq "ALL THE PAGES") {
		open(HTML,">$Con{'DataPath'}/HTMLList.them") || &ShowAdminError("FILE PROBLEM", "Couldn't create/write the HTMLList.them file.");
			print HTML $UltraRank::input{'HTML'};
		close(HTML);
		for ($i=0;$i<$Con{'NumSitesPage'};$i++) {
			open(HTML,">$Con{'DataPath'}/$Con{'ListFileName'}_$i.them") || &ShowAdminError("FILE PROBLEM", "Couldn't create/write the $Con{'ListFileName'}_$i.them file.");
				flock(HTML,2) if ($Con{'UseLock'});
					print HTML $UltraRank::input{'HTML'};
				flock(HTML,8) if ($Con{'UseLock'});
			close(HTML);
		}
	}else{
		open(HTML,">$Con{'DataPath'}/$Con{'ListFileName'}_$UltraRank::input{'PageNum'}.them") || &ShowAdminError("FILE PROBLEM", "Couldn't create/write the $Con{'ListFileName'}_$UltraRank::input{'PageNum'}.them file.");
			flock(HTML,2) if ($Con{'UseLock'});
				print HTML $UltraRank::input{'HTML'};
			flock(HTML,8) if ($Con{'UseLock'});
		close(HTML);
	}
	&MainMenu("MODIFIED HTML PAGES");
}

###############################################################################
# TablePro                                                                    #
###############################################################################
sub TablePro {
	&VerifyAdmin;
	&UltraRank::PrintHTMLHeader;
	&PrintHTMLTop;
	$HTMLTitle=$UltraRank::input{'ModifyFile'};
	$PageNum=$UltraRank::input{'ModifyFile'};
	$PageNum=~s/$Con{'ListFileName'}//g;
	$PageNum=~s/$Con{'ListFileExt'}//g;
	$PageNum=~s/\.//g;
	if ($PageNum eq "") {
		$PageNum=0;
	}
	$FileName=$Con{'ListFileName'}."_$PageNum.table";
	uc ($HTMLTitle);
	if ($UltraRank::input{'ModifyFile'} eq "ALL THE PAGES") {
		if (-e "$Con{'DataPath'}/HTMLList.table") {
			require "$Con{'DataPath'}/HTMLList.table";
		}
	}else{
		if (-e "$Con{'DataPath'}/$FileName") {
			require "$Con{'DataPath'}/$FileName";
		}
	}
	$ShowIn="";
	if ($Table{'ShowIn'} eq "on") {
		$ShowIn=" checked";
	}
	$ShowOut="";
	if ($Table{'ShowOut'} eq "on") {
		$ShowOut=" checked";
	}
	$ShowTotal="";
	if ($Table{'ShowTotal'} eq "on") {
		$ShowTotal=" checked";
	}
	print qq~
<form action="$Con{'URLCGI'}/URAdmin.pl" method="POST">
<input type=hidden name=action value="DoTablePro">
<input type=hidden name="Password" value="$UltraRank::input{'Password'}">
<input type=hidden name="ModifyFile" value="$UltraRank::input{'ModifyFile'}">
<input type=hidden name="PageNum" value="$PageNum">
<center><table width="580" border="0" cellspacing="0" cellpadding="1" bgcolor="black">
	<tr><td>
		<table width="100%" border="0" cellspacing="1" cellpadding="5">
			<tr><td bgcolor="#0080FF" colspan="2"><font face="Arial" size="2" color="White"><b>MODIFY TABLE PROPERTIES FOR $HTMLTitle</b></font></td></tr>
			<tr><td bgcolor="white" width="130">
				<font face="Arial" size="2"><b>Table width</b></font>
			</td><td bgcolor="silver" width="450">
				<input type="Text" name="TableWidth" value="$Table{'TableWidth'}" size="4" maxlength="4" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr><td bgcolor="white" width="130">
				<font face="Arial" size="2"><b>Table border color</b></font>
			</td><td bgcolor="silver" width="450">
				<input type="Text" name="TableBordColor" value="$Table{'TableBordColor'}" size="6" maxlength="6" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr><td bgcolor="white" width="130">
				<font face="Arial" size="2"><b>Table cellspacing</b></font>
			</td><td bgcolor="silver" width="450">
				<input type="Text" name="TableSpac" value="$Table{'TableSpac'}" size="2" maxlength="2" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr><td bgcolor="white" width="130">
				<font face="Arial" size="2"><b>Table cellpadding</b></font>
			</td><td bgcolor="silver" width="450">
				<input type="Text" name="TablePad" value="$Table{'TablePad'}" size="2" maxlength="2" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr><td bgcolor="white" width="130">
				<font face="Arial" size="2"><b>Table bgcolor</b></font>
			</td><td bgcolor="silver" width="450">
				<input type="Text" name="TableBGColor" value="$Table{'TableBGColor'}" size="6" maxlength="6" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr><td bgcolor="white" width="130">
				<font face="Arial" size="2"><b>Table background</b></font>
			</td><td bgcolor="silver" width="450">
				<input type="Text" name="TableBG" value="$Table{'TableBG'}" size="45" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr><td bgcolor="white" width="130">
				<font face="Arial" size="2"><b>Header BG Color</b></font>
			</td><td bgcolor="silver" width="450">
				<input type="Text" name="HeaderBGColor" value="$Table{'HeaderBGColor'}" size="45" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr><td bgcolor="white" width="130">
				<font face="Arial" size="2"><b>Header Text Face</b></font>
			</td><td bgcolor="silver" width="450">
				<input type="Text" name="HeaderTextFace" value="$Table{'HeaderTextFace'}" size="45" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr><td bgcolor="white" width="130">
				<font face="Arial" size="2"><b>Header Text Color</b></font>
			</td><td bgcolor="silver" width="450">
				<input type="Text" name="HeaderTextColor" value="$Table{'HeaderTextColor'}" size="45" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr><td bgcolor="white" width="130">
				<font face="Arial" size="2"><b>Header Text Size</b></font>
			</td><td bgcolor="silver" width="450">
				<input type="Text" name="HeaderTextSize" value="$Table{'HeaderTextSize'}" size="45" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr><td bgcolor="white" width="130">
				<font face="Arial" size="2"><b>Rank Text Face</b></font>
			</td><td bgcolor="silver" width="450">
				<input type="Text" name="RankTextFace" value="$Table{'RankTextFace'}" size="45" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr><td bgcolor="white" width="130">
				<font face="Arial" size="2"><b>Rank Text Color</b></font>
			</td><td bgcolor="silver" width="450">
				<input type="Text" name="RankTextColor" value="$Table{'RankTextColor'}" size="45" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr><td bgcolor="white" width="130">
				<font face="Arial" size="2"><b>Hits In/Out Text Face</b></font>
			</td><td bgcolor="silver" width="450">
				<input type="Text" name="HitTextFace" value="$Table{'HitTextFace'}" size="45" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr><td bgcolor="white" width="130">
				<font face="Arial" size="2"><b>Hits In/Out Text Color</b></font>
			</td><td bgcolor="silver" width="450">
				<input type="Text" name="HitTextColor" value="$Table{'HitTextColor'}" size="45" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr><td bgcolor="white" width="130">
				<font face="Arial" size="2"><b>Show Hits In </b></font>
			</td><td bgcolor="silver" width="450">
				<input type="Checkbox" name="ShowIn"$ShowIn>
			</td></tr>
			<tr><td bgcolor="white" width="130">
				<font face="Arial" size="2"><b>Show Hits Out</b></font>
			</td><td bgcolor="silver" width="450">
				<input type="Checkbox" name="ShowOut"$ShowOut>
			</td></tr>
			<tr><td bgcolor="white" width="130">
				<font face="Arial" size="2"><b>Show Total Hits In</b></font>
			</td><td bgcolor="silver" width="450">
				<input type="Checkbox" name="ShowTotal"$ShowTotal>
			</td></tr>
			<tr><td bgcolor="white" width="130">
				<font face="Arial" size="2"><b>Text Size</b></font>
			</td><td bgcolor="silver" width="450">
				<input type="Text" name="TextSize" value="$Table{'TextSize'}" size="45" style="font-family: Verdana; width: 100%;">
			</td></tr>
			<tr><td bgcolor="silver" colspan="2">
				<center><input type="Submit" value="MODIFY TABLE PROPERTIES" style="font-family: Arial; width: 100%;"></center>
			</td></tr>
		</table>
	</td></tr>
</table></center>
</form>
	~;
	&PrintHTMLBottom;
	exit;
}

###############################################################################
# DoTablePro                                                                  #
###############################################################################
sub DoTablePro {
	&VerifyAdmin;
	if ($UltraRank::input{'ModifyFile'} eq "ALL THE PAGES") {
		open(HTML,">$Con{'DataPath'}/HTMLList.table") || &ShowAdminError("FILE PROBLEM", "Couldn't create/write the HTMLList.table file.");
			flock(HTML,2) if ($Con{'UseLock'});
			print HTML<<TEXT;
\$Table{'TableWidth'}="$UltraRank::input{'TableWidth'}";
\$Table{'TableBordColor'}="$UltraRank::input{'TableBordColor'}";
\$Table{'TableSpac'}="$UltraRank::input{'TableSpac'}";
\$Table{'TablePad'}="$UltraRank::input{'TablePad'}";
\$Table{'TableBGColor'}="$UltraRank::input{'TableBGColor'}";
\$Table{'TableBG'}="$UltraRank::input{'TableBG'}";
\$Table{'HeaderBGColor'}="$UltraRank::input{'HeaderBGColor'}";
\$Table{'HeaderTextFace'}="$UltraRank::input{'HeaderTextFace'}";
\$Table{'HeaderTextColor'}="$UltraRank::input{'HeaderTextColor'}";
\$Table{'HeaderTextSize'}="$UltraRank::input{'HeaderTextSize'}";
\$Table{'RankTextFace'}="$UltraRank::input{'RankTextFace'}";
\$Table{'RankTextColor'}="$UltraRank::input{'RankTextColor'}";
\$Table{'HitTextFace'}="$UltraRank::input{'HitTextFace'}";
\$Table{'HitTextColor'}="$UltraRank::input{'HitTextColor'}";
\$Table{'TextSize'}="$UltraRank::input{'TextSize'}";
\$Table{'ShowIn'}="$UltraRank::input{'ShowIn'}";
\$Table{'ShowOut'}="$UltraRank::input{'ShowOut'}";
\$Table{'ShowTotal'}="$UltraRank::input{'ShowTotal'}";
1;
TEXT
			flock(HTML,8) if ($Con{'UseLock'});
		close(HTML);
		for ($i=0;$i<$Con{'NumSitesPage'};$i++) {
			open(HTML,">$Con{'DataPath'}/$Con{'ListFileName'}_$i.table") || &ShowAdminError("FILE PROBLEM", "Couldn't create/write the $Con{'ListFileName'}_$i.table file.");
				flock(HTML,2) if ($Con{'UseLock'});
					print HTML<<TEXT;
\$Table{'TableWidth'}="$UltraRank::input{'TableWidth'}";
\$Table{'TableBordColor'}="$UltraRank::input{'TableBordColor'}";
\$Table{'TableSpac'}="$UltraRank::input{'TableSpac'}";
\$Table{'TablePad'}="$UltraRank::input{'TablePad'}";
\$Table{'TableBGColor'}="$UltraRank::input{'TableBGColor'}";
\$Table{'TableBG'}="$UltraRank::input{'TableBG'}";
\$Table{'HeaderBGColor'}="$UltraRank::input{'HeaderBGColor'}";
\$Table{'HeaderTextFace'}="$UltraRank::input{'HeaderTextFace'}";
\$Table{'HeaderTextColor'}="$UltraRank::input{'HeaderTextColor'}";
\$Table{'HeaderTextSize'}="$UltraRank::input{'HeaderTextSize'}";
\$Table{'RankTextFace'}="$UltraRank::input{'RankTextFace'}";
\$Table{'RankTextColor'}="$UltraRank::input{'RankTextColor'}";
\$Table{'HitTextFace'}="$UltraRank::input{'HitTextFace'}";
\$Table{'HitTextColor'}="$UltraRank::input{'HitTextColor'}";
\$Table{'TextSize'}="$UltraRank::input{'TextSize'}";
\$Table{'ShowIn'}="$UltraRank::input{'ShowIn'}";
\$Table{'ShowOut'}="$UltraRank::input{'ShowOut'}";
\$Table{'ShowTotal'}="$UltraRank::input{'ShowTotal'}";
1;
TEXT
				flock(HTML,8) if ($Con{'UseLock'});
			close(HTML);
		}
	}else{
		open(HTML,">$Con{'DataPath'}/$Con{'ListFileName'}_$UltraRank::input{'PageNum'}.table") || &ShowAdminError("FILE PROBLEM", "Couldn't create/write the $Con{'ListFileName'}_$UltraRank::input{'PageNum'}.table file.");
			flock(HTML,2) if ($Con{'UseLock'});
				print HTML<<TEXT;
\$Table{'TableWidth'}="$UltraRank::input{'TableWidth'}";
\$Table{'TableBordColor'}="$UltraRank::input{'TableBordColor'}";
\$Table{'TableSpac'}="$UltraRank::input{'TableSpac'}";
\$Table{'TablePad'}="$UltraRank::input{'TablePad'}";
\$Table{'TableBGColor'}="$UltraRank::input{'TableBGColor'}";
\$Table{'TableBG'}="$UltraRank::input{'TableBG'}";
\$Table{'HeaderBGColor'}="$UltraRank::input{'HeaderBGColor'}";
\$Table{'HeaderTextFace'}="$UltraRank::input{'HeaderTextFace'}";
\$Table{'HeaderTextColor'}="$UltraRank::input{'HeaderTextColor'}";
\$Table{'HeaderTextSize'}="$UltraRank::input{'HeaderTextSize'}";
\$Table{'RankTextFace'}="$UltraRank::input{'RankTextFace'}";
\$Table{'RankTextColor'}="$UltraRank::input{'RankTextColor'}";
\$Table{'HitTextFace'}="$UltraRank::input{'HitTextFace'}";
\$Table{'HitTextColor'}="$UltraRank::input{'HitTextColor'}";
\$Table{'TextSize'}="$UltraRank::input{'TextSize'}";
\$Table{'ShowIn'}="$UltraRank::input{'ShowIn'}";
\$Table{'ShowOut'}="$UltraRank::input{'ShowOut'}";
\$Table{'ShowTotal'}="$UltraRank::input{'ShowTotal'}";
1;
TEXT
			flock(HTML,8) if ($Con{'UseLock'});
		close(HTML);
	}
	&MainMenu("MODIFIED TABLE PROPERTIES");
}

###############################################################################
# AdsBreaks                                                                   #
###############################################################################
sub AdsBreaks {
	&VerifyAdmin;
	&UltraRank::PrintHTMLHeader;
	&PrintHTMLTop;
	$Ads=int($Con{'NumSites'}/$Con{'NumSitesPage'});
	$Ads=int($Con{'NumSites'}/$Con{'NumSitesBreak'});
	$Ads-=$Con{'NumSitesPage'};
	print qq~
<form action="$Con{'URLCGI'}/URAdmin.pl" method="POST">
<input type=hidden name=action value="DoAdsBreaks">
<input type=hidden name="Password" value="$UltraRank::input{'Password'}">
<input type=hidden name="NumAds" value="$Ads">
<center><table width="580" border="0" cellspacing="0" cellpadding="1" bgcolor="black">
	<tr><td>
		<table width="100%" cellspacing="1" cellpadding="5" background="">
			<tr bgcolor="0080FF"><td colspan="2"><font face="Arial" color="FFFFFF" size="2"><b>ADS BREAKS</b></font></td></tr>
	~;
	for ($i=1;$i<=$Ads;$i++) {
		open(HTML,"$Con{'DataPath'}/Ads_$i.dat");
			@HTML=<HTML>;
		close(HTML);
		print qq~
			<tr bgcolor="CCCCCC"><td width="130" bgcolor="FFFFFF" valign="top">
				<font face="Verdana" color="000000" size="2"><b>Ads #$i</b></font>			
			</td><td>
		~;
		print qq~<textarea name="AdBreaks$i" cols="45" rows="5" style="font-family: Arial; width: 100%;" wrap="off">~;
		$Size=@HTML;
		for (@HTML) {
			print $_;
		}
		print qq~</textarea>~;
		print qq~
			</td></tr>
		~;
		undef @HTML;
	}
	print qq~
			<tr bgcolor="CCCCCC"><td colspan="2">
				<center><input type="Submit" value="MODIFY ADS BREAKS" style="font-family: Verdana; width: 100%;"></center>
			</td></tr>
		</table>
	</td></tr>
</table></center>
</form>
	~;
	&PrintHTMLBottom;
	exit;
}

###############################################################################
# DoAdsBreaks                                                                 #
###############################################################################
sub DoAdsBreaks {
	&VerifyAdmin;
	&UltraRank::PrintHTMLHeader;
	for ($i=1;$i<=$UltraRank::input{'NumAds'};$i++) {
		open(ADS,">$Con{'DataPath'}/Ads_$i.dat") || &ShowAdminError("FILE PROBLEM", "Couldn't create/write the Ads_$i.dat file.");
			flock(ADS,2) if ($Con{'UseLock'});
				print ADS $UltraRank::input{"AdBreaks".$i};
			flock(ADS,8) if ($Con{'UseLock'});
		close(ADS);
	}
	&MainMenu("MODIFIED ADS BREAKS");
}

###############################################################################
# EditWelcome                                                                 #
###############################################################################
sub EditWelcome {
	&VerifyAdmin;
	&UltraRank::PrintHTMLHeader;
	&PrintHTMLTop;
	open(HTML,"$Con{'DataPath'}/Welcome.dat");
		@HTML=<HTML>;
	close(HTML);
	print qq~
<form method=post action="URAdmin.pl">
<input type=hidden name="action" value="DoEditWelcome">
<input type=hidden name="Password" value="$UltraRank::input{'Password'}">
<table width="580" align="center" border="0" cellspacing="0" cellpadding="1" bgcolor="000000">
	<tr><td>
		<table width="100%" cellspacing="1" cellpadding="5" background="">
			<tr bgcolor="0080FF"><td><font face="Arial" color="FFFFFF" size="2"><b>MODIFY WELCOME EMAIL MESSAGE</b></font></td></tr>
			<tr bgcolor="CCCCCC"><td>
	~;
	print qq~<textarea name="MESSAGE" cols="45" rows="25" style="font-family: Arial; width: 100%;" wrap="off">~;
	$Size=@HTML;
	for (@HTML) {
		print $_;
	}
	print qq~</textarea>~;
	print qq~
			</td></tr>
			<tr bgcolor="CCCCCC"><td>
				<center><input type="Submit" value="SAVE WELCOME MESSAGE" style="font-family: Verdana; width: 100%;"></center>
			</td></tr>
		</table>
	</td></tr>
</table>
</form>
	~;
	&PrintHTMLBottom;
	exit;
}

###############################################################################
# DoEditWelcome                                                               #
###############################################################################
sub DoEditWelcome {
	&VerifyAdmin;
	&UltraRank::PrintHTMLHeader;
	open(WELCOME,">$Con{'DataPath'}/Welcome.dat") || &ShowAdminError("FILE PROBLEM", "Couldn't create/write the Welcome.dat file.");
		flock(WELCOME,2) if ($Con{'UseLock'});
			print WELCOME $UltraRank::input{'MESSAGE'};
		flock(WELCOME,8) if ($Con{'UseLock'});
	close(WELCOME);
	&MainMenu("MODIFIED WELCOME MESSAGE");
}

###############################################################################
# EditCode                                                                    #
###############################################################################
sub EditCode {
	&VerifyAdmin;
	&UltraRank::PrintHTMLHeader;
	&PrintHTMLTop;
	open(HTML,"$Con{'DataPath'}/Code.dat");
		@HTML=<HTML>;
	close(HTML);
	print qq~
<form method=post action="URAdmin.pl">
<input type=hidden name="action" value="DoEditCode">
<input type=hidden name="Password" value="$UltraRank::input{'Password'}">
<table width="580" align="center" border="0" cellspacing="0" cellpadding="1" bgcolor="000000">
	<tr><td>
		<table width="100%" cellspacing="1" cellpadding="5" background="">
			<tr bgcolor="0080FF"><td><font face="Arial" color="FFFFFF" size="2"><b>MODIFY THE CODE FOR MEMBERS</b></font></td></tr>
			<tr bgcolor="CCCCCC"><td bgcolor="FFFFFF">
				<font face="Verdana" color="000000" size="2"><b>
				Put <font color="Red"><--ULTRARANK_LINK--></font> in code template that where the link to get hits.<br>
				</b></font>
			</td></tr>
			<tr bgcolor="CCCCCC"><td>
	~;
	print qq~<textarea name="CODE" cols="45" rows="25" style="font-family: Arial; width: 100%;" wrap="off">~;
	$Size=@HTML;
	for (@HTML) {
		print $_;
	}
	print qq~</textarea>~;
	print qq~
			</td></tr>
			<tr bgcolor="CCCCCC"><td>
				<center><input type="Submit" value="SAVE THE CODE" style="font-family: Verdana; width: 100%;"></center>
			</td></tr>
		</table>
	</td></tr>
</table>
</form>
	~;
	&PrintHTMLBottom;
	exit;
}

###############################################################################
# DoEditCode                                                                  #
###############################################################################
sub DoEditCode {
	&VerifyAdmin;
	&UltraRank::PrintHTMLHeader;
	open(CODE,">$Con{'DataPath'}/Code.dat") || &ShowAdminError("FILE PROBLEM", "Couldn't create/write the Code.dat file.");
		flock(CODE,2) if ($Con{'UseLock'});
			print CODE $UltraRank::input{'CODE'};
		flock(CODE,8) if ($Con{'UseLock'});
	close(CODE);
	&MainMenu("MODIFIED THE CODE FOR MEMBERS");
}

###############################################################################
# EditGateway                                                                 #
###############################################################################
sub EditGateway {
	&VerifyAdmin;
	&UltraRank::PrintHTMLHeader;
	&PrintHTMLTop;
	open(HTML,"$Con{'DataPath'}/Gateway.dat");
		@HTML=<HTML>;
	close(HTML);
	print qq~
<form method=post action="URAdmin.pl">
<input type=hidden name="action" value="DoEditGateway">
<input type=hidden name="Password" value="$UltraRank::input{'Password'}">
<table width="580" align="center" border="0" cellspacing="0" cellpadding="1" bgcolor="000000">
	<tr><td>
		<table width="100%" cellspacing="1" cellpadding="5" background="">
			<tr bgcolor="0080FF"><td><font face="Arial" color="FFFFFF" size="2"><b>MODIFY ANTI-CHEAT GATEWAY MESSAGE</b></font></td></tr>
			<tr bgcolor="CCCCCC"><td bgcolor="FFFFFF">
				<font face="Verdana" color="000000" size="2"><b>
				Put <font color="Red"><--ULTRARANK_LINK--></font> in code template that where the link to get hits.<br>
				</b></font>
			</td></tr>
			<tr bgcolor="CCCCCC"><td>
	~;
	print qq~<textarea name="GATEWAY" cols="45" rows="25" style="font-family: Arial; width: 100%;" wrap="off">~;
	$Size=@HTML;
	for (@HTML) {
		print $_;
	}
	print qq~</textarea>~;
	print qq~
			</td></tr>
			<tr bgcolor="CCCCCC"><td>
				<center><input type="Submit" value="SAVE THE CODE" style="font-family: Verdana; width: 100%;"></center>
			</td></tr>
		</table>
	</td></tr>
</table>
</form>
	~;
	&PrintHTMLBottom;
	exit;
}

###############################################################################
# DoEditGateway                                                               #
###############################################################################
sub DoEditGateway {
	&VerifyAdmin;
	&UltraRank::PrintHTMLHeader;
	open(GATEWAY,">$Con{'DataPath'}/Gateway.dat") || &ShowAdminError("FILE PROBLEM", "Couldn't create/write the Gateway.dat file.");
		flock(GATEWAY,2) if ($Con{'UseLock'});
			print GATEWAY $UltraRank::input{'GATEWAY'};
		flock(GATEWAY,8) if ($Con{'UseLock'});
	close(GATEWAY);
	&MainMenu("MODIFIED THE ANTI-CHEAT GATEWAY MESSAGE");
}

###############################################################################
# ShowAdminError                                                              #
###############################################################################
sub ShowAdminError {
	local ($ErrorTitle, $ErrorMessage) = @_;
	&UltraRank::PrintHTMLHeader;
	if($Con{'LogErrors'}) {
		open(ERROR, ">>$Con{'DataPath'}/Errors.log");
			print ERROR time." | $ENV{'REMOTE_ADDR'} | $ErrorTitle | $ErrorMessage\n";
		close(ERROR);
	}
	&PrintHTMLTop;
	print qq~
<center><table width="580" border="0" cellspacing="0" cellpadding="1" bgcolor="black">
	<tr><td>
		<table width="100%" border="0" cellspacing="1" cellpadding="5">
			<tr><td bgcolor="#0080FF"><font face="Arial" size="2" color="White"><b>$ErrorTitle</b></font></td></tr>
			<tr><td bgcolor="silver">
				<table width="100%" border="0" cellspacing="0" cellpadding="10">
					<tr><td>
						<font face="Arial" size="2" color="Black">$ErrorMessage</font>
					</td></tr>
				</table>
			</td></tr>
			<tr><td bgcolor="silver">
				<center><input type="Button" value="< BACK" style="font-family: Arial; width: 100%;" onclick="history.go(-1)"></center>
			</td></tr>
		</table>
	</td></tr>
</table></center>
	~;
	&PrintHTMLBottom;
	exit;
}

###############################################################################
# ShowAdminThank                                                              #
###############################################################################
sub ShowAdminThank {
	local ($Title, $Message, $Redirect) = @_;
	&UltraRank::PrintHTMLHeader;
	print qq~
<html>
<head>
	<title>UltraRank Administrator Center</title>
	<meta http-equiv="REFRESH" content="3; url=$Redirect">
</head>
<body>
<center><table width="580" border="0" cellspacing="0" cellpadding="1" bgcolor="black">
	<tr><td>
		<table width="100%" border="0" cellspacing="1" cellpadding="5">
			<tr><td bgcolor="#0080FF"><font face="Arial" size="2" color="White"><b>$Title</b></font></td></tr>
			<tr><td bgcolor="silver">
				<table width="100%" border="0" cellspacing="0" cellpadding="10">
					<tr><td>
						<font face="Arial" size="2" color="Black">$Message</font>
					</td></tr>
				</table>
			</td></tr>
		</table>
	</td></tr>
</table></center>
	~;
	&PrintHTMLBottom;
	exit;
}

###############################################################################
# PrintHTMLTop                                                                #
###############################################################################
sub PrintHTMLTop {
	print qq~
<html>
<head>
	<title>UltraRank Administrator Center</title>
</head>
<body>
	~;
}

###############################################################################
# PrintHTMLBottom                                                             #
###############################################################################
sub PrintHTMLBottom {
	print qq~
</body>
</html>
	~;
}